Package: KEGGlincs
Type: Package
Title: Visualize all edges within a KEGG pathway and overlay LINCS data
Version: 1.38.0
Date: 2016-06-02
Author: Shana White
Maintainer: Shana White <vandersm@mail.uc.edu>, Mario Medvedovic <medvedm@ucmail.uc.edu>
Description: See what is going on 'under the hood' of KEGG pathways by
        explicitly re-creating the pathway maps from information
        obtained from KGML files.
License: GPL-3
RoxygenNote: 6.1.1
Depends: R (>= 3.3), KOdata, hgu133a.db, org.Hs.eg.db (>= 3.3.0)
SystemRequirements: Cytoscape (>= 3.3.0), Java (>= 8)
Suggests: BiocManager (>= 1.20.3), knitr, graph
biocViews: NetworkInference, GeneExpression, DataRepresentation,
        ThirdPartyClient,CellBiology,GraphAndNetwork,Pathways,KEGG,Network
Imports:
        AnnotationDbi,KEGGgraph,igraph,plyr,gtools,httr,RJSONIO,KEGGREST,
        methods,graphics,stats,utils, XML, grDevices
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/KEGGlincs
git_branch: RELEASE_3_23
git_last_commit: 78ba67f
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:52:24 UTC; biocbuild

#' Tidy up pathway by combining edges inside of edge_mapping_info
#' @description Combine edges that share nodes and have other commonalities
#' @export
#' @param edges The edge dataframe 
#' @param edge_id The numeric value for the edge_id
#' @param data_added A logical indicator; set to TRUE if data is added
#' @param by_significance A logical indicator; option if data is added
#' @param by_number A logical indicator; gives rough estimate of edge amount
#' @return A data frame that has had the given edge condensed for viewing
#' @importFrom grDevices col2rgb rgb
#' @examples \dontrun{
#' if (tidy_edge == TRUE) {
#'    edge_IDs <- seq(min(expanded_edges$edgeID), max(expanded_edges$edgeID))
#'    for (i in edge_IDs){
#'      if(data_added == TRUE){
#'        expanded_edges <- tidy_edge(edges = expanded_edges,
#'                                    edge_id = edge_IDs[i], 
#'                                    data_added = TRUE,
#'                                    by_significance = TRUE)
#'      }
#'      if(data_added == FALSE){
#'        expanded_edges <- tidy_edge(edges = expanded_edges,
#'                                    edge_id = edge_IDs[i], 
#'                                    data_added = FALSE)
#'      }
#'    }
#'
#'}
#'}

tidy_edge <- function(edges, edge_id, data_added = FALSE, 
                      by_significance = FALSE, by_number = TRUE){
  edge <- edges[edges$edgeID == edge_id,]
  edges_1 <- edges[edges$edgeID != edge_id,]
  if (!data_added){
    entry1accessions <- paste(unique(edge$entry1accession), collapse =",")
    entry2accessions <- paste(unique(edge$entry2accession), collapse =",")
    entry1symbols <- paste(unique(edge$entry1symbol), collapse = ",")
    entry2symbols <- paste(unique(edge$entry2symbol), collapse = ",")
    tooltip <- paste(entry1symbols, edge$value[1], entry2symbols)
    edge$entry1symbol[1] <- entry1symbols
    edge$entry2symbol[1] <- entry2symbols
    edge$entry1accession[1] <- entry1accessions
    edge$entry2accession[1] <- entry2accessions
    edge$tooltip[1] <- tooltip
    reduced_edge <- edge[1,]
  }
  if (data_added){
    if (sum(edge$has_data) == 0){
      entry1accessions <- paste(unique(edge$entry1accession), collapse =",")
      entry2accessions <- paste(unique(edge$entry2accession), collapse =",")
      entry1symbols <- paste(unique(edge$entry1symbol), collapse = ",")
      entry2symbols <- paste(unique(edge$entry2symbol), collapse = ",")
      tooltip <- paste(entry1symbols, edge$value[1], entry2symbols)
      edge$entry1symbol[1] <- entry1symbols
      edge$entry2symbol[1] <- entry2symbols
      edge$entry1accession[1] <- entry1accessions
      edge$entry2accession[1] <- entry2accessions
      edge$tooltip[1] <- tooltip
      reduced_edge <- edge[1,]
    }
    
    if (sum(edge$has_data) != 0 ){
      reduced_edge <- edge[edge$has_data != 0,]
      if(by_significance == TRUE){
        for (i in 1:length(unique(reduced_edge$color))){
          rp <- reduced_edge[reduced_edge$color == unique(reduced_edge$color)[i],]
          reduced_edge <- reduced_edge[reduced_edge$color != unique(reduced_edge$color)[i],]
          entry1accessions <- paste(unique(rp$entry1accession), collapse =",")
          entry2accessions <- paste(unique(rp$entry2accession), collapse =",")
          entry1symbols <- paste(unique(rp$entry1symbol), collapse = ",")
          entry2symbols <- paste(unique(rp$entry2symbol), collapse = ",")
          tooltip <- paste(unique(rp$tooltip), collapse = " , ")
          average_summary_score <- mean(rp$summary_score)
          rp$entry1symbol[1] <- entry1symbols
          rp$entry2symbol[1] <- entry2symbols
          rp$entry1accession[1] <- entry1accessions
          rp$entry2accession[1] <- entry2accessions
          rp$tooltip[1] <- tooltip
          rp$summary_score[1] <- average_summary_score
          
          if(by_number == TRUE) {
            col <- rp$color[1]
            thresh <- min(5, (nrow(rp)-1))
            value <- 1-(0.1*thresh)
            col1 <- round(value*(col2rgb(col)[1]))
            col2 <- round(value*(col2rgb(col)[2]))
            col3 <- round(value*(col2rgb(col)[3]))
            rp$color[1] <- rgb(col1, col2, col3, maxColorValue = 255)
          }    
          reduced_edge <- rbind(rp[1,], reduced_edge)
        }
      }
    }
  }
  edges <- rbind (edges_1, reduced_edge)
  return(edges)
}

#' Get overlap information for pairs of gene knock-outs from LINCS data
#' @export
#' @importFrom utils combn data
#' @import hgu133a.db
#' @import KOdata
#' @param KGML_file An object of formal class KEGGPathway
#' @param KEGG_mappings The data.frame object generated by the function 
#' expand_KEGG_mappings
#' @param cell_type Choose from the set of cell lines: 
#' (A375,A549,ASC,HA1E,HCC515,HEK293T,HEKTE,HEPG2,HT29,MCF7,NCIH716,NPC,PC3,
#' SHSY5Y,SKL,SW480,VCAP) 
#' @param data_type Choose from data types: (100_full, 100_bing, 50_lm)
#' @param pert_time Choose from (6,24,48,96,120,144,168)
#' @param only_mapped A logical indicator; if set to FALSE will return 'de-novo'
#' edges that 'exist' in data but are not documented in KEGG
#' @param affy_based A logical indicator; if set to TRUE will return 
#' lists/counts based on probeID instead of gene symbol.
#' @param keep_counts_only A logical indicator; if set to FALSE will return 
#' data frame with lists [of gene symbols or probe ids] as well as counts
#' @param add_fisher_information A logical indicator; by default the 
#' relationships are analyzed for strength of correlation via 
#' Fisher's Exact Test
#' @param p.adjust.method For available methods, type 'p.adjust.methods' into 
#' command promt and press enter.
#' @return A data frame where each row corresponds to information for pairs of 
#' experimental gene knock-outs from LINCS data (found in selected pathway).   
#' @examples 
#' p53_KGML <- get_KGML("hsa04115")
#' p53_KEGG_mappings <-  expand_KEGG_mappings(p53_KGML)
#' p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)
#' 
#' summary <- path_genes_by_cell_type(p53_KEGG_mappings)
#' p53_HA1E_data <- overlap_info(p53_KGML, p53_KEGG_mappings, 
#'                                "HA1E", data_type = "100_bing", 
#'                                only_mapped = FALSE)

overlap_info <- 
    function(KGML_file, KEGG_mappings, cell_type, 
                        data_type = "100_full",pert_time = 96,
                        only_mapped = TRUE, affy_based = FALSE,
                        keep_counts_only = TRUE, 
                        add_fisher_information = TRUE, 
                        p.adjust.method = "BH"){
    data("KO_data", envir = environment())
    KO_data <- get("KO_data")
    if(!cell_type %in% unique(KO_data$cell_id)){
        warning("Knock-out data is not available for selected cell-line \n")
        overlaps <- data.frame("null" = NA)
        return(overlaps)
        }
    KO_by_CT <- KO_data[KO_data$pert_time == pert_time & 
                        KO_data$cell_id == cell_type,]
    expanded_edges <- expand_KEGG_edges(KGML_file, KEGG_mappings)
    keeps <- c("entry1symbol", "entry2symbol")
    expanded_edges <- expanded_edges[expanded_edges$type != "maplink",keeps]
    if(nrow(expanded_edges) == 0 & only_mapped){
        warning("No documented edges are found in data; 
            only data for de-novo edges can be generated \n")
        overlaps <- data.frame("null" = NA)
        return(overlaps)
    }

    keeps <- c("entryACCESSION", "entrySYMBOL")
    path_genes <- KEGG_mappings[KEGG_mappings$entryTYPE == "gene", keeps]
    names(path_genes)[2] <- "SYMBOL"
    path_genes <- data.frame("ENTREZID" = unlist(path_genes$entryACCESSION), 
                            "SYMBOL" = unlist(path_genes$SYMBOL), 
                            stringsAsFactors = FALSE)
    path_genes <- path_genes[!duplicated(path_genes$ENTREZID),]
    data <- subset(path_genes, path_genes$SYMBOL %in% KO_by_CT$pert_desc)

    cat(paste0("Number of genes documented in selected pathway = ", 
                nrow(path_genes)), "\n")
    cat(paste0("Number of pathway genes in dataset = ", nrow(data),"\n"))
    cat(paste0("Coverage = ", round(nrow(data)/nrow(path_genes),4)*100,
                "%","\n"))
    if(nrow(data) == 0 | nrow(data) == 1){
        warning("Overlap data for selected pathway cannot be generated for 
            selected cell line")
        overlaps <- data.frame("null" = NA)
        return(overlaps)
    }

    conversion_key <- suppressWarnings(suppressMessages(
        AnnotationDbi::select(hgu133a.db::hgu133a.db, 
        AnnotationDbi::keys(hgu133a.db), c("SYMBOL","ENTREZID"), "PROBEID")))
  
    for (i in 1:nrow(data)){
        if (data_type == "100_full"){
            data$up[i] <- 
                strsplit(KO_by_CT$up100_full[KO_by_CT$pert_desc == 
                                                data$SYMBOL[i]], ";")
            data$down[i] <- 
                strsplit(KO_by_CT$dn100_full[KO_by_CT$pert_desc == 
                                                data$SYMBOL[i]], ";")
        }
        else if (data_type == "100_bing"){
            data$up[i] <- 
                strsplit(KO_by_CT$up100_bing[KO_by_CT$pert_desc == 
                                                data$SYMBOL[i]], ";")
            data$down[i] <- 
                strsplit(KO_by_CT$dn100_bing[KO_by_CT$pert_desc == 
                                                data$SYMBOL[i]], ";")
        }
        else if (data_type == "50_lm"){
            data$up[i] <- 
                strsplit(KO_by_CT$up50_lm[KO_by_CT$pert_desc == 
                                            data$SYMBOL[i]], ";")
            data$down[i] <- 
                strsplit(KO_by_CT$dn50_lm[KO_by_CT$pert_desc == 
                                            data$SYMBOL[i]], ";")
        }
        else {
            warning("valid data_type options: 100_full, 100_bing, 50_lm")
            return(NA)
        }
        data$up_symbol[i] <- 
            list(conversion_key$SYMBOL[which(conversion_key$PROBEID %in% 
                                            unlist(data$up[i]))])
        data$down_symbol[i] <-
            list(conversion_key$SYMBOL[which(conversion_key$PROBEID %in% 
                                            unlist(data$down[i]))])
    }
    overlaps<- data.frame(t(combn(data$SYMBOL,2)), stringsAsFactors = FALSE)
    names(overlaps) <- c("knockout1", "knockout2")
    overlaps$unique_ID <- paste0(overlaps$knockout1, ",", overlaps$knockout2)
    expanded_edges$unique_ID <- paste0(expanded_edges$entry1symbol, ",", 
                                    expanded_edges$entry2symbol)
    expanded_edges$unique_IDR <- paste0(expanded_edges$entry2symbol, ",", 
                                    expanded_edges$entry1symbol)
    pre_mapped1 <- subset(overlaps, overlaps$unique_ID %in% 
                        expanded_edges$unique_ID) ## Direction is correct
    pre_mapped2 <- subset(overlaps, overlaps$unique_ID %in% 
                        expanded_edges$unique_IDR) ## Direction is reversed
    pre_mapped2 <- pre_mapped2[,c(2,1)]
    names(pre_mapped2)[c(1,2)] = names(pre_mapped1)[c(1,2)]
    if(nrow(pre_mapped2) >= 1 & nrow(pre_mapped1) >= 1){
        pre_mapped2$unique_ID <- paste0(pre_mapped2$knockout1, ",", 
                                    pre_mapped2$knockout2)
        pre_mapped <- rbind(pre_mapped1, pre_mapped2)
    }
    if (nrow(pre_mapped2) == 0 & (nrow(pre_mapped1) == 0)){
        pre_mapped <- data.frame("unique_ID" = NA)
    }
    if (nrow(pre_mapped1) == 0 & nrow(pre_mapped2) >= 1){
        pre_mapped2$unique_ID <- paste0(pre_mapped2$knockout1, ",", 
                                    pre_mapped2$knockout2)
        pre_mapped <- pre_mapped2
    }
    if (nrow(pre_mapped2) == 0 & nrow(pre_mapped1) >= 1){
        pre_mapped <- pre_mapped1
    }
    if(is.na(pre_mapped[1,1]) & only_mapped){
        warning("No documented edges are found in data; only data for 
                de-novo edges can be generated \n")
        overlaps <- data.frame("null" = NA)
        return(overlaps)
    }
    pre_mapped$pre_mapped <- 1
    keeps <-c("knockout1", "knockout2", "pre_mapped")
    pre_mapped <- pre_mapped[,keeps]
    if (!only_mapped){
        un_mapped <- subset(overlaps, !overlaps$unique_ID %in% 
                        expanded_edges$unique_ID & !overlaps$unique_ID %in% 
                        expanded_edges$unique_IDR)
        un_mapped$pre_mapped <- 0
        un_mapped <- un_mapped[,keeps]
        overlaps <- rbind(pre_mapped, un_mapped)
    }
    else {
        overlaps <- pre_mapped
    }
    for (i in 1:nrow(overlaps)){
        overlaps$affy.genesUP[i] <- 
            list(intersect(unlist(data$up[which(data$SYMBOL == overlaps[i,1])]),
                        unlist(data$up[which(data$SYMBOL == overlaps[i,2])])))
    overlaps$affy.genesDOWN[i] <- 
        list(intersect(unlist(data$down[which(data$SYMBOL == overlaps[i,1])]), 
                        unlist(data$down[which(data$SYMBOL == overlaps[i,2])])))
    overlaps$affy.genesUPK1_DOWNK2[i] <- 
        list(intersect(unlist(data$up[which(data$SYMBOL == overlaps[i,1])]), 
                        unlist(data$down[which(data$SYMBOL == overlaps[i,2])])))
    overlaps$affy.genesDOWNK1_UPK2[i] <- 
        list(intersect(unlist(data$down[which(data$SYMBOL == overlaps[i,1])]), 
                        unlist(data$up[which(data$SYMBOL == overlaps[i,2])])))
    overlaps$num.affy.genesUP[i] <- length(unlist(overlaps$affy.genesUP[i]))
    overlaps$num.affy.genesDOWN[i] <- length(unlist(overlaps$affy.genesDOWN[i]))
    overlaps$num.affy.genesUPK1_DOWNK2[i] <- 
        length(unlist(overlaps$affy.genesUPK1_DOWNK2[i]))
    overlaps$num.affy.genesDOWNK1_UPK2[i] <- 
        length(unlist(overlaps$affy.genesDOWNK1_UPK2[i]))
    }
    if (!affy_based){
        for(i in 1:nrow(overlaps)){
            overlaps$genes.symbolsUP[i]<- 
                list(conversion_key$SYMBOL[which(conversion_key$PROBEID %in% 
                                        unlist(overlaps$affy.genesUP[i]))])
            overlaps$genes.symbolsDOWN[i]<- 
                list(conversion_key$SYMBOL[which(conversion_key$PROBEID %in% 
                                        unlist(overlaps$affy.genesDOWN[i]))])
        overlaps$genes.symbolsUPK1_DOWNK2[i]<- 
            list(conversion_key$SYMBOL[which(conversion_key$PROBEID %in% 
                                unlist(overlaps$affy.genesUPK1_DOWNK2[i]))])
        overlaps$genes.symbolsDOWNK1_UPK2[i]<- 
            list(conversion_key$SYMBOL[which(conversion_key$PROBEID %in% 
                                unlist(overlaps$affy.genesDOWNK1_UPK2[i]))])
        overlaps$num.genes.symbolsUP[i] <- 
            length(unlist(overlaps$genes.symbolsUP[i]))
        overlaps$num.genes.symbolsDOWN[i] <- 
            length(unlist(overlaps$genes.symbolsDOWN[i]))
        overlaps$num.genes.symbolsUPK1_DOWNK2[i] <- 
            length(unlist(overlaps$genes.symbolsUPK1_DOWNK2[i]))
        overlaps$num.genes.symbolsDOWNK1_UPK2[i] <- 
            length(unlist(overlaps$genes.symbolsDOWNK1_UPK2[i]))
        }
        keeps = c("knockout1","knockout2","num.genes.symbolsUP", 
                    "num.genes.symbolsDOWN", "num.genes.symbolsUPK1_DOWNK2", 
                    "num.genes.symbolsDOWNK1_UPK2", "genes.symbolsUP", 
                    "genes.symbolsDOWN", "genes.symbolsUPK1_DOWNK2", 
                    "genes.symbolsDOWNK1_UPK2", "pre_mapped")
        overlaps <- overlaps[,keeps]
    }
    else {
        keeps = c("knockout1","knockout2","num.affy.genesUP", 
                "num.affy.genesDOWN", "num.affy.genesUPK1_DOWNK2", 
                "num.affy.genesDOWNK1_UPK2", "affy.genesUP", "affy.genesDOWN", 
                "affy.genesUPK1_DOWNK2", "affy.genesDOWNK1_UPK2", "pre_mapped")
        overlaps <- overlaps[, keeps]
    }
    names(overlaps)[c(3:6)] <- c("UP", "DOWN", "UK1_DK2", "DK1_UK2")
    method = p.adjust.method
    if (keep_counts_only){
        keeps = c("knockout1","knockout2", "UP", "DOWN", "UK1_DK2", "DK1_UK2", 
                "pre_mapped")
        overlaps <- overlaps[,keeps]
        }
    if(add_fisher_information){
        overlaps <- get_fisher_info(overlaps, method)
    }
    return(overlaps)
}

## ----render_overview_png,eval=TRUE,echo=FALSE,out.width=800-------------------
knitr::include_graphics("image_files/KEGGlincs_overview.jpeg")

## ----initialize, message = FALSE, warning=FALSE-------------------------------
library(KEGGlincs)

## ----get_KGML, collapse=TRUE--------------------------------------------------
FoxO_KGML <- get_KGML("hsa04068")

#Information from KGML can be accessed using the following syntax:
slot(FoxO_KGML, "pathwayInfo")

## ----access_KGML, collapse=TRUE-----------------------------------------------
#Get address for pathway with active links:
slot(slot(FoxO_KGML, "pathwayInfo"), "image")

## ----get_png, eval = FALSE----------------------------------------------------
# #Download a static pathway image (png file) to working directory:
# image_link <- slot(slot(FoxO_KGML, "pathwayInfo"), "image")
# download.file(image_link, basename(image_link), mode = "wb")

## ----render_png,eval=TRUE,echo=FALSE,out.width=800----------------------------
knitr::include_graphics("image_files/hsa04068.png")

## ----speed_up_for_ex, echo=FALSE----------------------------------------------
FoxO_KEGG_mappings <- expand_KEGG_mappings(FoxO_KGML, convert_KEGG_IDs = FALSE)

## ----expand_mapping_for_show, eval=FALSE--------------------------------------
# FoxO_KEGG_mappings <- expand_KEGG_mappings(FoxO_KGML)

## ----expand_edges-------------------------------------------------------------
FoxO_edges <- expand_KEGG_edges(FoxO_KGML, FoxO_KEGG_mappings)

## ----compare_lengths, collapse=TRUE-------------------------------------------
length(graph::nodes(FoxO_KGML)) # 'Un-expanded' nodes
nrow(FoxO_KEGG_mappings)        # 'Expanded' nodes

length(graph::edges(FoxO_KGML)) # 'Un-expanded' edges
nrow(FoxO_edges)                # 'Expanded' edges

## ----mapping_info, collapse=TRUE----------------------------------------------
#Modify existing data sets; specify as nodes and edges
FoxO_node_mapping_info <- node_mapping_info(FoxO_KEGG_mappings)
FoxO_edge_mapping_info <- edge_mapping_info(FoxO_edges)

#Create an igraph object
GO <- get_graph_object(FoxO_node_mapping_info, FoxO_edge_mapping_info)
class(GO)

## ----cyto_vis, collapse=TRUE, eval=FALSE--------------------------------------
# cyto_vis(GO, "FoxO Pathway with Expanded Edges[no data added]")

## ----render_graph,eval=TRUE,echo=FALSE,out.width=800--------------------------
knitr::include_graphics("image_files/foxo_ID_conversion.jpeg")

## ----eval = FALSE-------------------------------------------------------------
# KEGG_lincs("hsa04068")

## ----eval = FALSE-------------------------------------------------------------
# FoxO_edges <- KEGG_lincs("hsa04068")

## ----eval = FALSE, echo = TRUE------------------------------------------------
# KEGG_lincs("hsa04068", convert_KEGG_IDs = FALSE)

## ----render_graph_fast,eval=TRUE,echo=FALSE,out.width=800---------------------
knitr::include_graphics("image_files/foxo_no_IDconversion.jpeg")

## ----show_KO_data, eval=TRUE,echo=FALSE,out.width=800-------------------------
knitr::include_graphics("image_files/random_KO_info.jpeg")

## ----default_p53, eval = FALSE, echo = TRUE-----------------------------------
# KEGG_lincs("hsa04115")

## ----show_p53_default, eval=TRUE,echo=FALSE,out.width=800---------------------
knitr::include_graphics("image_files/p53_default.jpeg")

## ----begin_workflow1----------------------------------------------------------
p53_KGML <- get_KGML("hsa04115")
p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML)
p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)

## ----show_pathway_genes, eval=FALSE-------------------------------------------
# path_genes_by_cell_type(p53_KEGG_mappings)

## ----render_barplot, eval=TRUE,echo=FALSE,out.width=500-----------------------
knitr::include_graphics("image_files/p53_coverage_graph.png")

## ----show_summary_for_ex, eval = FALSE----------------------------------------
# p53_L1000_summary <- path_genes_by_cell_type(p53_KEGG_mappings, get_KOs = TRUE)

## ----avoid_poor_map_render, echo=FALSE----------------------------------------
p53_L1000_summary <- path_genes_by_cell_type(p53_KEGG_mappings, get_KOs = TRUE,
                                                generate_plot = FALSE)

knitr::kable(tail(p53_L1000_summary))

## ----overlap_info, eval=TRUE, collapse=TRUE-----------------------------------
p53_PC3_data <- overlap_info(p53_KGML, p53_KEGG_mappings, "PC3")

p53_HA1E_data <- overlap_info(p53_KGML, p53_KEGG_mappings, "HA1E")

## ----show_overlap_data, echo = FALSE------------------------------------------
knitr::kable(head(p53_PC3_data[1:6]))

## ----overlap_info_plus_genes, eval=TRUE, collapse=TRUE------------------------
p53_PC3_data_with_gene_lists <- overlap_info(p53_KGML, p53_KEGG_mappings, 
                                            "PC3", keep_counts_only = FALSE)

## ----show_overlap_data_plus_genes_PC3, echo = FALSE---------------------------
knitr::kable(head(p53_PC3_data_with_gene_lists[c(1:2, 7:10)]))

## ----add_edges----------------------------------------------------------------
p53_PC3_edges <- add_edge_data(p53_edges, p53_KEGG_mappings,
                                    p53_PC3_data, only_mapped = TRUE,
                                    data_column_no = c(3,10,12))

p53_HA1E_edges <- add_edge_data(p53_edges, p53_KEGG_mappings,
                                p53_HA1E_data, only_mapped = TRUE,
                                data_column_no =  c(3,10,12))

## ----get_mapping_info, eval = FALSE-------------------------------------------
# p53_node_map <- node_mapping_info(p53_KEGG_mappings)
# 
# p53_edge_map_PC3 <- edge_mapping_info(p53_PC3_edges, data_added = TRUE,
#                                         significance_markup = TRUE)
# p53_edge_map_HA1E <- edge_mapping_info(p53_HA1E_edges, data_added = TRUE,
#                                         significance_markup = TRUE)
# 
# 
# PC3_GO <- get_graph_object(p53_node_map, p53_edge_map_PC3)
# HA1E_GO <- get_graph_object(p53_node_map, p53_edge_map_HA1E)
# 
# cyto_vis(PC3_GO, "Pathway = p53, Cell line = PC3")
# #Option: Save PC3 as .cys file and start a fresh session in Cytoscape
# cyto_vis(HA1E_GO, "Pathway = p53, Cell line = HA1E")

## ----render_graphs,eval=TRUE,echo=FALSE,out.width=800-------------------------
knitr::include_graphics("image_files/p53_PC3_vignette.jpeg")
knitr::include_graphics("image_files/p53_HA1E_vignette.jpeg")

## ----auto_map, eval = FALSE---------------------------------------------------
# KEGG_lincs("hsa04115", "PC3", refine_by_cell_line = FALSE)
# KEGG_lincs("hsa04115", "HA1E", refine_by_cell_line = FALSE)

## ----render_graphs_kegglincs,eval=TRUE,echo=FALSE,out.width=800---------------
knitr::include_graphics("image_files/p53_PC3.jpeg")
knitr::include_graphics("image_files/p53_HA1E.jpeg")

#' Annotate KEGG edge mappings with user data
#' @description Add data column[s] to object created from function 
#' expand_KEGG_edges 
#' @export
#' @importFrom gtools smartbind
#' @importFrom plyr rename
#' @param expanded_edges The data frame object generated via the function 
#' expand_KEGG_edges  
#' @param KEGG_mappings KEGG_mappings The data.frame object generated by the 
#' function expand_KEGG_mappings
#' @param user_data A data frame where in which the first two columns contain 
#' gene symbols representing an edge and any/all other column[s] contain 
#' corresponding edge data.
#' @param data_column_no The column index for desired user data to be added
#' @param map_type If the genes in your data set are left untranslated 
#' set to "NUMBER" (assuming numbers are gene accession numbers) 
#' @param only_mapped A logical indicator; if set to FALSE will return 'de-novo'
#' edges that 'exist' in data but are not documented in KEGG 
#' @return A data frame object with detailed KEGG edge mappings annotated with 
#' user data
#' @examples 
#' p53_KGML <- get_KGML('hsa04115')
#' p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML)
#' p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)
#' p53_HA1E_data <- overlap_info(p53_KGML, p53_KEGG_mappings, 'HA1E', 
#'                                data_type = '100_bing', only_mapped = FALSE)
#'                                
#' p53_edges_HA1E <- add_edge_data(p53_edges, p53_KEGG_mappings, 
#'                                         p53_HA1E_data, c(3, 10,12))


add_edge_data <- function(expanded_edges, KEGG_mappings,
                          user_data, data_column_no = 3, map_type = "SYMBOL",
                          only_mapped = TRUE) {
    
    expanded_edges <- expanded_edges[expanded_edges$type != "maplink", ]
    if (nrow(expanded_edges) > 0) {
        if (map_type == "SYMBOL"){
            expanded_edges$unique_ID = 
                paste0(expanded_edges$entry1symbol, ",",
                expanded_edges$entry2symbol)
            expanded_edges$unique_IDR = 
                paste0(expanded_edges$entry2symbol, ",",
                expanded_edges$entry1symbol)
        }
        if (map_type == "NUMBER"){
            expanded_edges$unique_ID = 
                paste0(expanded_edges$entry1accession, ",",
                expanded_edges$entry2accession)
            expanded_edges$unique_IDR = 
                paste0(expanded_edges$entry2accession, ",",
                expanded_edges$entry1accession)
        }
        
        user_data$unique_ID = paste0(user_data[,1], ",",
                                     user_data[,2])
        pre_mapped1 <- subset(user_data, user_data$unique_ID %in%
                                  expanded_edges$unique_ID)
        pre_mapped2 <- subset(user_data, user_data$unique_ID %in%
                                  expanded_edges$unique_IDR)
        pre_mapped2 <- pre_mapped2[, c(2, 1, 3:ncol(pre_mapped2))]
        names(pre_mapped2) = names(pre_mapped1)
        if (nrow(pre_mapped2) >= 1 & nrow(pre_mapped1) >= 1) {
            pre_mapped2$unique_ID <- paste0(pre_mapped2[,1], ",",
                                            pre_mapped2[,2])
            pre_mapped <- rbind(pre_mapped1, pre_mapped2)
        }
        if (nrow(pre_mapped2) == 0 & (nrow(pre_mapped1) == 0)) {
            pre_mapped <- data.frame(unique_ID = NA)
        }
        if (nrow(pre_mapped1) == 0 & nrow(pre_mapped2) >= 1) {
            pre_mapped2$unique_ID <- paste0(pre_mapped2[,1], ",",
                                            pre_mapped2[,2])
            pre_mapped <- pre_mapped2
        }
        if (nrow(pre_mapped2) == 0 & nrow(pre_mapped1) >= 1) {
            pre_mapped <- pre_mapped1
        }
        if (!is.na(pre_mapped[1, 1])) {
            expanded_edges_1 <- subset(expanded_edges, expanded_edges$unique_ID
                                       %in% pre_mapped$unique_ID)
            expanded_edges_1 <- expanded_edges[expanded_edges$unique_ID %in%
                                                   pre_mapped$unique_ID, ]
            expanded_edges_2 <- expanded_edges[!expanded_edges$unique_ID %in%
                                                   pre_mapped$unique_ID, ]
            expanded_edges_1$has_data = 1
            testval <- nrow(expanded_edges_2)
            if (testval > 0) {
                expanded_edges_2$has_data = 0
                edge_set <- rbind(expanded_edges_1, expanded_edges_2)
            }
            else {
                edge_set <- expanded_edges_1
            }
            
            edge_set <- edge_set[order(edge_set$unique_ID), ]
            
            data_to_add <- data.frame("unique_ID" = pre_mapped$unique_ID, stringsAsFactors = FALSE)
            data_to_add <- cbind(data_to_add, pre_mapped[, data_column_no])
            
            data_to_add <- data_to_add[order(data_to_add$unique_ID), ]
            colnames(data_to_add)[2] <- "summary_score"
            
            annotated_edges <- merge(edge_set, data_to_add, "unique_ID",
                                     all.x = TRUE)
            drops <- c("unique_ID", "unique_IDR")
            annotated_edges <- annotated_edges[, !(names(annotated_edges) %in%
                                                       drops)]
            cat(paste0("Number of edges documented in selected pathway = ",
                       nrow(annotated_edges)), "\n")
            cat(paste0("Number of edges with corresponding user data = ",
                       sum(annotated_edges$has_data), "\n"))
            cat(paste0("Coverage = ", round(sum(annotated_edges$has_data)/
                                                nrow(annotated_edges) * 100, 2), "%", "\n"))
            annotated_edges$premapped <- 1
            # un_mapped <- subset(user_data, !user_data$unique_ID %in%
            #                       expanded_edges$unique_ID &
            #                       !user_data$unique_ID %in% expanded_edges$unique_IDR)
            # un_mapped_edges <- un_mapped[, c(1:2, data_column_no,
            #                                  ncol(un_mapped))]
            
            if (only_mapped) {
                return(annotated_edges)
            }
        }
        else {
            annotated_edges <- expanded_edges
            annotated_edges$premapped <- 1
            annotated_edges$has_data <- 0
            un_mapped <- user_data
            un_mapped$unique_ID <- paste0(un_mapped$knockout1,
                                          un_mapped$knockout2)
            un_mapped_edges <- un_mapped[, c(1:2, data_column_no,
                                             ncol(un_mapped))]
            un_mapped_edges$premapped <- 0
            un_mapped_edges$has_data <- 0
            cat(paste0("Number of edges documented in selected pathway = ",
                       nrow(annotated_edges)), "\n")
            cat(paste0("Number of edges with corresponding user data = ",
                       sum(annotated_edges$has_data), "\n"))
            cat(paste0("Coverage = ", round(sum(annotated_edges$has_data)/
                                                nrow(annotated_edges) * 100, 2), "%", "\n"))
            if (only_mapped) {
                cat(paste0("No documented edges are found in data;
                           only data for de-novo edges can be mapped \n"))
                return(annotated_edges)
            }
        }
        }
    else if (nrow(expanded_edges) == 0) {
        annotated_edges <- expanded_edges
        annotated_edges$premapped <- 1
        annotated_edges$has_data <- 0
        un_mapped <- user_data
        un_mapped$unique_ID <- paste0(un_mapped$knockout1, un_mapped$knockout2)
        un_mapped_edges <- un_mapped[, c(1:2, data_column_no, ncol(un_mapped))]
        un_mapped_edges$premapped <- 0
        un_mapped_edges$has_data <- 0
        cat(paste0("Number of edges documented in selected pathway = ",
                   nrow(annotated_edges)), "\n")
        cat(paste0("Number of edges with corresponding user data = ",
                   sum(annotated_edges$has_data), "\n"))
        cat(paste0("Coverage = ", round(sum(annotated_edges$has_data)/
                                            nrow(annotated_edges) * 100, 2), "%", "\n"))
        if (only_mapped) {
            return(annotated_edges)
        }
    }
    names(un_mapped_edges)[1:2] <- c("entryNAME_1", "entryNAME_2")
    for (i in 1:nrow(un_mapped_edges)) {
        un_mapped_edges$Source_eid[i] <-
            list(KEGG_mappings$entryID[which(KEGG_mappings$entrySYMBOL ==
                                                 un_mapped_edges$entryNAME_1[i])])
        un_mapped_edges$Target_eid[i] <-
            list(KEGG_mappings$entryID[which(KEGG_mappings$entrySYMBOL ==
                                                 un_mapped_edges$entryNAME_2[i])])
        x <- length(unlist(un_mapped_edges$Source_eid[i]))
        y <- length(unlist(un_mapped_edges$Target_eid[i]))
        if (x > 1 | y > 1) {
            un_mapped_edges$simple[i] <- FALSE
        } else {
            un_mapped_edges$simple[i] <- TRUE
        }
    }
    simple_un_mapped_edges <- un_mapped_edges[un_mapped_edges$simple == TRUE,
                                              -ncol(un_mapped_edges)]
    complex_un_mapped_edges <- un_mapped_edges[un_mapped_edges$simple == FALSE,
                                               -ncol(un_mapped_edges)]
    test_val <- nrow(complex_un_mapped_edges)
    if (test_val == 0) {
        un_mapped_edges <- simple_un_mapped_edges
    } else {
        keeps <- c("Source_eid", "Target_eid", "unique_ID")
        c_temp <- complex_un_mapped_edges[, (names(complex_un_mapped_edges) %in%
                                                 keeps)]
        
        for (i in 1:nrow(c_temp)) {
            x <- length(unlist(c_temp$Source_eid[i]))
            y <- length(unlist(c_temp$Target_eid[i]))
            l <- x * y
            
            c_temp$Source_eid[i] <- list(sort(unlist(rep(c_temp$Source_eid[i],
                                                         y))))
            c_temp$Target_eid[i] <- list(unlist(rep(c_temp$Target_eid[i], x)))
            c_temp$unique_ID[i] <- list(rep(c_temp$unique_ID[i], l))
        }
        
        c_temp <- data.frame(unique_ID = unlist(c_temp$unique_ID), Source_eid =
                                 unlist(c_temp$Source_eid),
                             Target_eid = unlist(c_temp$Target_eid))
        drops <- c("Source_eid", "Target_eid")
        complex_un_mapped_edges <-
            complex_un_mapped_edges[, !(names(complex_un_mapped_edges) %in%
                                            drops)]
        complex_un_mapped_edges <- merge(complex_un_mapped_edges, c_temp)
        un_mapped_edges <- rbind(simple_un_mapped_edges,
                                 complex_un_mapped_edges)
    }
    un_mapped_edges$Source_eid <- unlist(un_mapped_edges$Source_eid)
    un_mapped_edges$Target_eid <- unlist(un_mapped_edges$Target_eid)
    un_mapped_edges <- plyr::rename(un_mapped_edges, c(Source_eid = "entry1",
                                                       Target_eid = "entry2", entryNAME_1 = "entry1symbol",
                                                       entryNAME_2 = "entry2symbol"))
    un_mapped_edges$subtype1 <- "de_novo"
    
    drops <- c("unique_ID")
    un_mapped_edges <- un_mapped_edges[, !(names(un_mapped_edges) %in% drops)]
    un_mapped_edges$has_data <- 1
    un_mapped_edges$premapped <- 0
    for (i in 1:nrow(un_mapped_edges)) {
        un_mapped_edges$entry1accession[i] <-
            KEGG_mappings$entryACCESSION[which(KEGG_mappings$entrySYMBOL ==
                                                   un_mapped_edges$entry1symbol[i])][1]
        un_mapped_edges$entry2accession[i] <-
            KEGG_mappings$entryACCESSION[which(KEGG_mappings$entrySYMBOL ==
                                                   un_mapped_edges$entry2symbol[i])][1]
        un_mapped_edges$entry1type[i] <-
            KEGG_mappings$entryTYPE[which(KEGG_mappings$entrySYMBOL ==
                                              un_mapped_edges$entry1symbol[i])][1]
        un_mapped_edges$entry2type[i] <-
            KEGG_mappings$entryTYPE[which(KEGG_mappings$entrySYMBOL ==
                                              un_mapped_edges$entry2symbol[i])][1]
    }
    
    if (nrow(annotated_edges) > 0 & nrow(un_mapped_edges) > 0) {
        all_edges <- gtools::smartbind(annotated_edges, un_mapped_edges)
    } else if (nrow(annotated_edges) > 0)
        all_edges <- annotated_edges else {
            all_edges <- un_mapped_edges
            all_edges$value <- NA
            all_edges$subtype2 <- NA
            all_edges$value2 <- NA
            all_edges$specific_subtype <- NA
            all_edges$type <- NA
            all_edges$is_direct <- 1
            all_edges$edgeID <- seq(1:nrow(un_mapped_edges))
            refcols <- c("edgeID", "entry1accession", "entry2accession", "entry1",
                         "entry2")
            all_edges <- all_edges[, c(refcols, setdiff(names(all_edges), refcols))]
            cat(paste0("All documented edges are of type maplink; only data for
                       de-novo edges can be mapped \n"))
        }
    
    for (i in 1:nrow(all_edges)) {
        if (all_edges$entry1[i] == all_edges$entry2[i]) {
            all_edges$paralogs[i] <- 1
        } else {
            all_edges$paralogs[i] <- 0
        }
    }
    return(all_edges)
        }

#' Combines all other package functions for one-step cell line comparison
#' @export
#' @param pathwayid A KEGG pathway ID of the form "hsa12345" 
#' (only human pathways currently)
#' @param cell_line1 Choose from the set of cell lines: 
#' (A375,A549,ASC,HA1E,HCC515,HEK293T,HEKTE,HEPG2,HT29,MCF7,NCIH716,NPC,PC3,
#' SHSY5Y,SKL,SW480,VCAP)
#' @param cell_line2 A cell line such that cell_line1 != cell_line2
#' @param refine_by_cell_line A logical indicator
#' @param data_type Choose from data types: (100_full, 100_bing, 50_lm)
#' @param pert_time Choose from (6,24,48,96,120,144,168)
#' @param only_mapped A logical indicator; if set to FALSE will return 'de-novo'
#' edges that 'exist' in data but are not documented in KEGG
#' @param layered_nodes A logical indicator; if set to TRUE will create a graph 
#' with 'stacked' nodes that the user can manipulate when multiple nodes are 
#' mapped to one location
#' @param graph_title An optional user-specified graph title
#' @param tidy_edge A logical indicator; must be set to FALSE for expanded edges
#' @param get_data A logical indicator; if set to true, will return the 
#' 'expanded' edge information for the specified pathway
#' @param convert_KEGG_IDs A logical indicator; if set to TRUE KEGG 
#' compounds will remain labeled via KEGG codes (do not need KEGGREST)
#' @return  A dynamic map in Cytoscape automatically formatted for convenient 
#' viewing and, if idicated by user, a data.frame object with detailed 
#' information for 'expanded' KEGG edges
#' @examples \dontrun{ 
#' 
#' # Compare p53 pathway between cell lines A375 and A549:
#' KL_compare("hsa04115", "A375", "A549")
#'}

KL_compare <-
    function(pathwayid, cell_line1 = NA, cell_line2 = NA,
             refine_by_cell_line = TRUE,
             data_type = "100_full",
             pert_time = 96,
             only_mapped = TRUE,
             get_data = FALSE,
             convert_KEGG_IDs = TRUE,
             graph_title = "default",
             tidy_edge = TRUE,
             layered_nodes = FALSE){
        cell_lines <- c("A375","A549","ASC","HA1E","HCC515","HEK293T","HEKTE",
                        "HEPG2","HT29","MCF7","NCIH716","NPC","PC3","SHSY5Y",
                        "SKL","SW480","VCAP")
        if (is.na(cell_line1)){
            warning(paste0(
                'Please choose one of the following for cell_line1: ', 
                cell_lines))
            return()
        }
        if (is.na(cell_line2)){
            warning(paste0('Please choose one the following for cell_line2: ',
                           list(cell_lines[cell_lines != cell_line1])))
            return()
        }
        
        if (cell_line2 == cell_line1){
            warning(paste0('cell_line1 = cell_line2; ', 
                           'please choose from the following for cell_line2: ',
                           list(cell_lines[cell_lines != cell_line1])))
            return()
        }
        
        KGML <- get_KGML(pathwayid, get_if_no_edges = TRUE)
        if(!isS4(KGML)){
            return()
        }
        KEGG_mappings <- 
            expand_KEGG_mappings(KGML,convert_KEGG_IDs = convert_KEGG_IDs)
        if (refine_by_cell_line) {
            full_mappings1 <- KEGG_mappings
            KEGG_mappings1 <- refine_mappings(KEGG_mappings, cell_line1)
            for (i in 1:nrow(full_mappings1)){
                if(!full_mappings1$entryID[i] %in% KEGG_mappings$entryID){
                    full_mappings1$BGcolor[i] <- "#d3d3d3"
                    full_mappings1$in_relationship <- 0
                }
            }
            full_mappings2 <- KEGG_mappings
            KEGG_mappings2 <- refine_mappings(KEGG_mappings, cell_line2)
            for (i in 1:nrow(full_mappings2)){
                if(!full_mappings2$entryID[i] %in% KEGG_mappings$entryID){
                    full_mappings2$BGcolor[i] <- "#d3d3d3"
                    full_mappings2$in_relationship <- 0
                }
            }
        }
        expanded_edges <- expand_KEGG_edges(KGML, KEGG_mappings)
        if(expanded_edges$type[1] == "dummy"){
            graph_title <- paste0("Pathway = ", pathwayid, ":", 
                                  KGML@pathwayInfo@title,
                                  "Cell-Lines: ", 
                                  paste0(cell_line1,",", cell_line2), 
                                  "  *No Edges in Pathway")
        }
        
        if (nrow(expanded_edges[expanded_edges$type == "maplink",]) == 
            nrow(expanded_edges) & only_mapped) {
            edge_map <- edge_mapping_info(expanded_edges)
            if (graph_title == "default"){
                graph_title <- paste0("Pathway = ", pathwayid, ":", 
                                      KGML@pathwayInfo@title, "Cell-Lines: ", 
                                      paste0(cell_line1,",", cell_line2), 
                                       "  *No Edges in Data")
            }
            warning("All documented edges are of type 'maplink'; 
                    Overlap data cannot be mapped to selected pathway")
        }
        cell_data1 <- overlap_info(KGML, KEGG_mappings, cell_line1, 
                                   data_type = data_type, 
                                   pert_time = pert_time)
        
        cell_data2 <- overlap_info(KGML, KEGG_mappings, cell_line2, 
                                   data_type = data_type, 
                                   pert_time = pert_time)
        
        for (i in 1:nrow(cell_data1)){
            UP <- cell_data1$UP[i] + 0.5
            DOWN <- cell_data1$DOWN[i] + 0.5
            UK1_DK2 <- cell_data1$UK1_DK2[i] + 0.5
            DK1_UK2 <- cell_data1$DK1_UK2[i] + 0.5
            cell_data1$OR_1[i] <- (UP*DOWN)/(UK1_DK2*DK1_UK2)
            cell_data1$SE_1[i] <-sqrt(1/UP + 1/DOWN + 1/UK1_DK2 + 1/DK1_UK2)
            cell_data1$log_OR_1[i] <- log(cell_data1$OR_1[i])
        }
        
        for (i in 1:nrow(cell_data2)){
            UP <- cell_data2$UP[i] + 0.5
            DOWN <- cell_data2$DOWN[i] + 0.5
            UK1_DK2 <- cell_data2$UK1_DK2[i] + 0.5
            DK1_UK2 <- cell_data2$DK1_UK2[i] + 0.5
            cell_data2$OR_2[i] <- (UP*DOWN)/(UK1_DK2*DK1_UK2)
            cell_data2$SE_2[i] <-sqrt(1/UP + 1/DOWN + 1/UK1_DK2 + 1/DK1_UK2)
            cell_data2$log_OR_2[i] <- log(cell_data2$OR_2[i])
        }
        
        if (!is.na(cell_data1)[1,1] & !is.na(cell_data2)[1,1]) {
            edges_plus_data1 <- add_edge_data(expanded_edges, KEGG_mappings, 
                                              cell_data1, c(15,16), 
                                              map_type = "SYMBOL",
                                              only_mapped = only_mapped)
            edges_plus_data2 <- add_edge_data(expanded_edges, KEGG_mappings, 
                                              cell_data2, c(15,16), 
                                              map_type = "SYMBOL",
                                              only_mapped = only_mapped)
            names(edges_plus_data1)[18] <- "SE_1"
            names(edges_plus_data2)[18] <- "SE_2"
            edges_plus_data1$unique_ID <- paste0(edges_plus_data1$entry1symbol, 
                                                 ":", edges_plus_data1$entry2symbol, 
                                                 ":", edges_plus_data1$edgeID)
            edges_plus_data2$unique_ID <- paste0(edges_plus_data2$entry1symbol, 
                                                 ":", edges_plus_data2$entry2symbol, 
                                                 ":", edges_plus_data2$edgeID)
            
            edges_compare <- merge(edges_plus_data1, edges_plus_data2[,c(18,19,21)], 
                                    by = "unique_ID")
            
            for(i in 1:nrow(edges_compare)){
                if (!is.na(edges_compare$log_OR_1[i]) & 
                    !is.na(edges_compare$log_OR_2[i])){
                    edges_compare$test[i] <- (edges_compare$log_OR_1[i] - 
                                                  edges_compare$log_OR_2[i])/
                        sqrt(edges_compare$SE_1[i]^2 + edges_compare$SE_2[i]^2)
                    edges_compare$summary_score[i] <- exp(abs(edges_compare$test[i]))
                    
                    
                    if (edges_compare$test[i] <= stats::qnorm(0.1) | 
                        edges_compare$test[i] >= stats::qnorm(0.9)){
                        edges_compare$significant[i] <- 1
                    }
                    else {
                        edges_compare$significant[i] <- 0
                    }
                }
                else {
                    edges_compare$test[i] <- NA
                    edges_compare$summary_score[i] <- 0
                    edges_compare$significant[i] <- NA
                }
            }
            
            edge_map <- edge_mapping_info(edges_compare, data_added = TRUE)
            for (i in 1:nrow(edge_map)){
                if (is.na(edge_map$test[i])){
                    edge_map$has_data[i] <- 0
                    edge_map$color[i] <- "#808080"
                }
            }
            if ("premapped" %in% names (edge_map)) {
                premapped <- edge_map$premapped
                drop <- "premapped"
                edge_map <- edge_map[, ! names(edge_map) %in% drop]
                edge_map$premapped <- premapped
            }
            for (i in 1:nrow(edge_map)){
                if (!is.na(edge_map$log_OR_1[i]) & 
                    !is.na(edge_map$log_OR_2[i])){
                    if (edge_map$test[i] < 0){
                        if (edge_map$significant[i] == 0){
                            edge_map$color[i] <- "#82E0AA"
                        }
                        if (edge_map$significant[i] == 1){
                            edge_map$color[i] <- "#1E8449"
                        }
                    }
                    if (edge_map$test[i] > 0){
                        if (edge_map$significant[i] == 0){
                            edge_map$color[i] <- "#E67E22"
                        }
                        if (edge_map$significant[i] == 1){
                            edge_map$color[i] <- "#BA4A00"
                        }
                    }
                }
            }
            if (tidy_edge == TRUE) {
                edge_IDs <- seq(min(edge_map$edgeID), max(edge_map$edgeID))
                for (i in edge_IDs){
                    edge_map <- tidy_edge(edges = edge_map, 
                                          edge_id = edge_IDs[i],
                                          by_significance = TRUE)
                }
            }
            
            if (graph_title == "default"){
                graph_title <- paste0("Pathway = ", pathwayid, ":",
                                      KGML@pathwayInfo@title, " - ",
                                      cell_line1 ,"vs", cell_line2, ", 
                                      Data type: ", data_type)
            }
            }
        
        node_map <- node_mapping_info(KEGG_mappings)
        
        graph_object <- get_graph_object(node_map, edge_map, 
                                         layered_nodes = layered_nodes)
        
        edge_width_attribute = "summary_score"
        
        if (edge_width_attribute %in% names(igraph::edge_attr(graph_object))){
            min.summary_score <- min(abs(igraph::E(graph_object)$summary_score),
                                     na.rm = TRUE)
            max.summary_score <- max(abs(igraph::E(graph_object)$summary_score), 
                                     na.rm = TRUE)
            map_edge_width <- TRUE
        }
        
        cyto_vis(graph_object, title = graph_title, 
                 edge_width_attribute = "summary_score")
        if(get_data){
            return(edge_map)
        }
    }

#' Get detailed KEGG mapping information for each map entity
#' @description Extract mapping information from KGML object and normalize 
#' mappings based on multi-valued name attribute
#'
#' @param KGML_file An object of formal class KEGGPathway
#' @param convert_KEGG_IDs A logical indicator; if set to FALSE will run faster
#'  however genes and compounds will remain labeled via KEGG codes (compounds) 
#'  or accession numbers (genes).  This option must be taken into account if 
#'  data is being added.  For example, the genes in 'KO_data' are identified by
#'  symbols, thus it is neccessary to retain the default option to convert IDs
#'  to symbols when planning to add edge data of this type.
#'
#' @return A dataframe object with unique entry information for all [node]
#'  objects documented in the KEGG pathway. 
#'         Note that if mutiple objects (i.e. genes or compounds) have the same 
#'         entryID, this indicates that they share the same node [location] 
#'         in the pathway.  
#' @export
#' @import org.Hs.eg.db 
#' @import KEGGREST
#' @import AnnotationDbi
#' @importMethodsFrom KEGGgraph edges
#' @importMethodsFrom KEGGgraph nodes
#' @examples
#' p53_KGML <- get_KGML("hsa04115")
#' p53_KEGG_mappings <-  expand_KEGG_mappings(p53_KGML, FALSE)

expand_KEGG_mappings <-
function (KGML_file, convert_KEGG_IDs = TRUE){
    nodesN <- KEGGgraph::nodes(KGML_file)
    entryMAP<- data.frame(entry = seq(1:length(nodesN)))
    for (i in 1:nrow(entryMAP)){
        entryMAP$entryID[i] <- nodesN[[i]]@entryID
        entryMAP$entryTYPE[i] <- nodesN[[i]]@type
        entryMAP$entryIDENTIFIER[i] <- list(nodesN[[i]]@name)
        if (entryMAP$entryTYPE[i] == "group"){
            entryMAP$groupMEMBERS[i] <-
                list(nodesN[[entryMAP$entryID[i]]]@component)
            entryMAP$entryIDENTIFIER[i] <- 
                list(entryMAP$entryIDENTIFIER[which(entryMAP$entryID %in% 
                                            unlist(entryMAP$groupMEMBERS[i]))])
        }
        else {
            entryMAP$groupMEMBERS[i] <- NA
        }
        if (entryMAP$entryTYPE[i] == "gene" | 
            entryMAP$entryTYPE[i] == "compound"|
            entryMAP$entryTYPE[i] == "group"){
                entryMAP$entryACCESSION[i]<- list(gsub(".*:", "", 
                                        unlist(entryMAP$entryIDENTIFIER[i])))
        }
        else {
            entryMAP$entryACCESSION[i] <- NA
        }
        entryMAP$entryTYPE[i] <- nodesN[[i]]@type
        entryMAP$entryNAMES[i] <- nodesN[[i]]@graphics@name
        entryMAP$FGcolor[i] <- nodesN[[i]]@graphics@fgcolor
        entryMAP$BGcolor[i] <- nodesN[[i]]@graphics@bgcolor
        entryMAP$shape[i] <- nodesN[[i]]@graphics@type
        entryMAP$Xcoord[i] <- nodesN[[i]]@graphics@x
        entryMAP$Ycoord[i] <- nodesN[[i]]@graphics@y
        entryMAP$width[i] <- nodesN[[i]]@graphics@width
        entryMAP$height[i] <- nodesN[[i]]@graphics@height
        if(is.na(entryMAP$entryNAMES[i])){
            entryMAP$entryNAMES[i] <- "NoNameInKGML"
        }
    }
    entryMAP <- entryMAP[,-c(1,4)]
    entryMAP_groupings <- entryMAP[entryMAP$entryTYPE == "group",]
    entryMAP_extra <- entryMAP[entryMAP$entryTYPE == "map",]
    entryMAP_extra$entrySYMBOL <- NA
    entryMAP_dictionary <- entryMAP[entryMAP$entryTYPE == "gene" | 
                                    entryMAP$entryTYPE == "compound",]
    for (i in 1:nrow(entryMAP_dictionary)){  
        if (entryMAP_dictionary$entryTYPE[i] == "compound"){
            entryMAP_dictionary$entryACCESSION[i] <- 
            entryMAP_dictionary$entryACCESSION[[i]][1]
        }
    }
    if(convert_KEGG_IDs){
        for (i in 1:nrow(entryMAP_dictionary)){  
            if (entryMAP_dictionary$entryTYPE[i] == "compound"){
                testval <- 
                    keggGet(entryMAP_dictionary$entryACCESSION[i])[[1]]$NAME
                if(!is.null(testval)){
                    entryMAP_dictionary$entryNAMES[i] <- list(testval)
                    entryMAP_dictionary$entryNAMES[i] <- 
                        list(gsub(";", "",
                                unlist(entryMAP_dictionary$entryNAMES[i])))
                }
            }
        }
    }
    for (i in 1:nrow(entryMAP_dictionary)){  
        l = length(unlist(entryMAP_dictionary$entryACCESSION[i]))
        entryMAP_dictionary$entryID[i] <- 
            list(rep(entryMAP_dictionary$entryID[i], l))
        entryMAP_dictionary$entryTYPE[i] <- 
            list(rep(entryMAP_dictionary$entryTYPE[i], l))
    }
    emd_temp <- data.frame(cbind(unlist(entryMAP_dictionary$entryID), 
                                unlist(entryMAP_dictionary$entryTYPE), 
                                unlist(entryMAP_dictionary$entryACCESSION)), 
                                stringsAsFactors = FALSE)
    names(emd_temp) <- names(entryMAP[c(1,2,4)])
    for (i in 1:nrow(emd_temp)){
        if (emd_temp$entryTYPE[i] == "gene"){
            if (convert_KEGG_IDs){
                emd_temp$entrySYMBOL[i] <- 
                suppressMessages(as.character(AnnotationDbi::select(
                org.Hs.eg.db::org.Hs.eg.db,keys = emd_temp$entryACCESSION[i], 
                columns=c("SYMBOL"),keytype="ENTREZID")[2]))
            }
            else {
                emd_temp$entrySYMBOL[i] <- emd_temp$entryACCESSION[i]
            }
        }
        else if (emd_temp$entryTYPE[i] == "compound"){
            emd_temp$entrySYMBOL[i] <- unlist(
                entryMAP_dictionary$entryNAMES[
                    entryMAP_dictionary$entryACCESSION == 
                    emd_temp$entryACCESSION[i]])[1]
        }
        else {
            emd_temp$entrySYMBOL[i] <- NA
        }
    }
    for (i in 1:nrow(emd_temp)){
        if (gsub("[[:digit:]]","",emd_temp$entryACCESSION[i]) == "G" & 
            is.na(emd_temp$entrySYMBOL[i])){
            emd_temp$entrySYMBOL[i] <- emd_temp$entryACCESSION[i]
        }
    }
    emd_temp$groupMEMBERS <- NA
    for(i in 1:nrow(entryMAP_dictionary)){
        entryMAP_dictionary$entryID[i] <- 
            unlist(entryMAP_dictionary$entryID[i])[1] 
        entryMAP_dictionary$entryTYPE[i] <- 
            unlist(entryMAP_dictionary$entryTYPE[i])[1]
        if(entryMAP_dictionary$entryTYPE[i] == "compound"){
            entryMAP_dictionary$entryNAMES[i] <- 
                toString(unlist(entryMAP_dictionary$entryNAMES[[i]]))
        }
    }
    entryMAP_dictionary <- entryMAP_dictionary[,-c(2:4)]
    entryMAP_dictionary <- merge(emd_temp, entryMAP_dictionary, by = "entryID")
    if (nrow(entryMAP_groupings) > 0){
        for(i in 1:nrow(entryMAP_groupings)){
            entryMAP_groupings$entrySYMBOL[i] <- 
                list(entryMAP_dictionary$entrySYMBOL[match(unlist(
                    entryMAP_groupings$entryACCESSION[i]),
                    entryMAP_dictionary$entryACCESSION)])
        }
        entryMAP_dictionary <- 
            rbind(entryMAP_extra, entryMAP_dictionary, entryMAP_groupings)
        no_groups <- FALSE
    }
    if (nrow(entryMAP_groupings) == 0){
        entryMAP_dictionary <- rbind(entryMAP_extra, entryMAP_dictionary)
        entryMAP_dictionary$groupMEMBERS <- NA
        entryMAP_dictionary$groupID <- NA
        no_groups = TRUE
    }

    entryMAP_dictionary <- 
        entryMAP_dictionary[order(as.double(entryMAP_dictionary$entryID)),]
    rownames(entryMAP_dictionary) <- seq(1:nrow(entryMAP_dictionary))
    entryMAP_dictionary$entryNAMES <- gsub("...", "", 
                                            entryMAP_dictionary$entryNAMES,
                                            fixed = TRUE)
    for (i in 1:nrow(entryMAP_dictionary)){
        if (entryMAP_dictionary$entryTYPE[i] =="gene"){
            entryMAP_dictionary$LABEL[i] <- strsplit(as.character(
                entryMAP_dictionary$entryNAMES[[i]]), ",")[[1]][1]
        }
        else if (entryMAP_dictionary$entryTYPE[i] == "compound"){
            entryMAP_dictionary$LABEL[i] <- entryMAP_dictionary$entrySYMBOL[i]
        }
        else {
            entryMAP_dictionary$LABEL[i] = entryMAP_dictionary$entryNAMES[i]
        }
    }
    for (i in 1:nrow(entryMAP_dictionary)){
        if (entryMAP_dictionary$entryTYPE[i] == "group"){
            entryMAP_dictionary$entryNAMES[i] <- 
                paste0(paste(unique(entryMAP_dictionary$LABEL[which(
                entryMAP_dictionary$entryID %in% 
                unlist(entryMAP_dictionary$groupMEMBERS[i]))]),collapse = ":"),
                " Complex")
            entryMAP_dictionary$LABEL[i] <- entryMAP_dictionary$entryNAMES[i]
        }
    }
    if (!no_groups){
        for (i in 1:nrow(entryMAP_groupings)){
            l <- length(unlist(entryMAP_groupings$groupMEMBERS[i]))
            entryMAP_groupings$entryID[i] <-  
                list(rep(entryMAP_groupings$entryID[i], l))
        }
        group_mapper <- data.frame("groupID" = 
                                    unlist(entryMAP_groupings$entryID), 
                            "entryID" = 
                                unlist(entryMAP_groupings$groupMEMBERS),
                            stringsAsFactors = FALSE)
        for (i in 1:nrow(entryMAP_dictionary)){
            if (entryMAP_dictionary$entryID[i] %in% group_mapper$entryID){
                entryMAP_dictionary$groupID[i] <-
                    group_mapper$groupID[match(entryMAP_dictionary$entryID[i],
                                        group_mapper$entryID)]
            }
            else {
                entryMAP_dictionary$groupID[i] <- NA
            }
        }
    }

    num_edges <- length(KGML_file@edges)
    if (num_edges > 0){
        map_edge_data<- KEGGgraph::edges(KGML_file)
        edges<- data.frame(edgeID = seq(1:length(map_edge_data )))
        for (i in 1:nrow(edges)){
            edges$entry1[i] <- as.character(map_edge_data[[i]]@entry1ID)
            edges$entry2[i] <- as.character(map_edge_data[[i]]@entry2ID)
        }
        for (i in 1:nrow(entryMAP_dictionary)){
            if (entryMAP_dictionary$entryID[i] %in% edges$entry1 | 
                entryMAP_dictionary$entryID[i] %in% edges$entry2){
                    entryMAP_dictionary$in_relationship[i] = 1
            }
            else if (entryMAP_dictionary$groupID[i] %in% edges$entry1 | 
                    entryMAP_dictionary$groupID[i] %in% edges$entry2){
                    entryMAP_dictionary$in_relationship[i] = 1
            }
            else {
                entryMAP_dictionary$in_relationship[i] = 0
            }
        }
    }
    if (num_edges == 0){
      entryMAP_dictionary$in_relationship = 0
    }
    for (i in 1:nrow(entryMAP_dictionary)){
        if (is.na(entryMAP_dictionary$entrySYMBOL[i])){
            entryMAP_dictionary$entrySYMBOL[i] <- entryMAP_dictionary$LABEL[i]
        }
    }
    map_nodes <- entryMAP_dictionary$LABEL[entryMAP_dictionary$entryTYPE=="map"]
    j = 0
    for (i in 1:length(map_nodes)){
        if (substring(map_nodes[i],1,5) == "TITLE"){
            j = j+1
        }
    }
    if (j == 0){
        title <- KGML_file@pathwayInfo@title
        min_Y <- min(entryMAP_dictionary$Ycoord)
        min_X <- min(entryMAP_dictionary$Xcoord)+100
        title_node <- data.frame("entryID" = 0, "entryTYPE" = "map", 
                                "groupMEMBERS" = NA, "entryACCESSION" = NA, 
                                "entryNAMES" = title,
                                "FGcolor" = "#000000", "BGcolor" = "#FFFFFF",
                                "shape" = "rectangle", "Xcoord" = min_X, 
                                "Ycoord"= min_Y, "height" = 25, "width" = 220, 
                                "entrySYMBOL"= title, "groupID"=NA,
                                "LABEL"=paste0("TITLE:",title), 
                                "in_relationship" = 0)
        entryMAP_dictionary <- rbind(entryMAP_dictionary, title_node)
    }
    return(entryMAP_dictionary)
}

#' cyREST utility functions
#' @description A subset of the R utility functions available from/defined
#'  by cyREST.  The function mapAttributes is called from within toCytoscape 
#'  which, in turn, is called from within cyto_vis. 
#' @export
#' @import methods
#' @importFrom igraph E edge_attr graph.attributes V vertex.attributes
#'  list.vertex.attributes get.edgelist ecount edge.attributes 
#'  list.edge.attributes
#' @param attr.names Attribute names of an igraph object
#' @param all.attr The attribute value if an igraph object
#' @param i The index for a given igraph object
#' @param igraphobj A graph object compatible for use with the package igraph
#' @return A JSON object to be sent to Cytoscape 


toCytoscape <- 
  function (igraphobj) {
    # Extract graph attributes
    graph_attr = graph.attributes(igraphobj)
    
    # Extract nodes
    node_count = length(V(igraphobj))
    if('name' %in% list.vertex.attributes(igraphobj)) {
      V(igraphobj)$id <- V(igraphobj)$name
    } else {
      V(igraphobj)$id <- as.character(c(1:node_count))
    }
    
    nodes <- V(igraphobj)
    v_attr = vertex.attributes(igraphobj)
    v_names = list.vertex.attributes(igraphobj)
    
    nds <- array(0, dim=c(node_count))
    for(i in 1:node_count) {
      if(i %% 1000 == 0) {
        print(i)
      }
      nds[[i]] = list(data = mapAttributes(v_names, v_attr, i))
    }
    
    edges <- get.edgelist(igraphobj)
    edge_count = ecount(igraphobj)
    e_attr <- edge.attributes(igraphobj)
    e_names = list.edge.attributes(igraphobj)
    
    attr_exists = FALSE
    e_names_len = 0
    if(identical(e_names, character(0)) == FALSE) {
      attr_exists = TRUE
      e_names_len = length(e_names)
    }
    e_names_len <- length(e_names)
    
    eds <- array(0, dim=c(edge_count))
    for(i in 1:edge_count) {
      st = list(source=toString(edges[i,1]), target=toString(edges[i,2]))
      
      # Extract attributes
      if(attr_exists) {
        eds[[i]] = list(data=c(st, mapAttributes(e_names, e_attr, i)))
      } else {
        eds[[i]] = list(data=st)
      }
      
      if(i %% 1000 == 0) {
        print(i)
      }
    }
    
    el = list(nodes=nds, edges=eds)
    
    x <- list(data = graph_attr, elements = el)
    print("Done.  To json Start...")
    return (RJSONIO::toJSON(x))
  }

#' @rdname toCytoscape
mapAttributes <-
  function(attr.names, all.attr, i) {
    attr = list()
    cur.attr.names = attr.names
    attr.names.length = length(attr.names)
    
    for(j in 1:attr.names.length) {
      if(is.na(all.attr[[j]][i]) == FALSE) {
        #       attr[j] = all.attr[[j]][i]
        attr <- c(attr, all.attr[[j]][i])
      } else {
        cur.attr.names <- cur.attr.names[cur.attr.names != attr.names[j]]
      }
    }
    names(attr) = cur.attr.names
    return (attr)
  }

#' Refine pathway by cell type
#' @description Reduce the KEGG pathway by only including genes that are 
#' expressed within a given cell type
#' @export
#' @param KEGG_mappings The data.frame object generated by the function 
#' expand_KEGG_mappings
#' @param cell_line Choose from the set of cell lines with baseline data; 
#' cell-lines may or may not have corresponding KO data
#' @return A dataframe object with reduced set of pathway mappings to be
#'  passed on to other functions
#' @examples
#' p53_KGML <- get_KGML("hsa04115")
#' p53_KEGG_mappings <-  expand_KEGG_mappings(p53_KGML)
#' MCF7_p53_mappings <- refine_mappings(p53_KEGG_mappings, "MCF7")

refine_mappings <- function(KEGG_mappings, cell_line){
  data("gene_cell_info", envir = environment())
  gene_cell_info <- get("gene_cell_info")
  
  if (!cell_line %in% gene_cell_info$cell){
    warning("Baseline expression data not available for selected cell type; 
            pathway will not be refined")
    return(KEGG_mappings)
  }
  
  chosen_cell_info <- gene_cell_info[gene_cell_info$cell == cell_line,]
  gene_nodes <- KEGG_mappings[KEGG_mappings$entryTYPE == "gene",]
  non_gene_nodes <- KEGG_mappings[KEGG_mappings$entryTYPE != "gene",]
  
  genes_with_info <- gene_nodes[gene_nodes$entrySYMBOL %in% 
                                  chosen_cell_info$pr_gene_symbol,]

  for (i in 1:nrow(genes_with_info)){
    genes_with_info$is_expressed[i] <- 
      chosen_cell_info$is_expressed[which(chosen_cell_info$pr_gene_symbol == 
                                            genes_with_info$entrySYMBOL[i])]
  }
  genes_expressed_in_cell_type <- 
    genes_with_info[genes_with_info$is_expressed == TRUE,]
  genes_expressed_in_cell_type <- genes_expressed_in_cell_type[, -c(17)]
  refined_mappings <- rbind(non_gene_nodes, genes_expressed_in_cell_type)
  
  return(refined_mappings)
}

#' Download and parse KGML file
#' @export  
#' @param pathwayid A KEGG pathway ID of the form "hsa12345" 
#' (only human pathways currently)
#' @param get_if_no_edges A logical indicator; if pathway has no edges 
#' returns null value if set to TRUE
#' @return an object of Formal class KEGGPathway
#' @examples 
#' mtor_KGML <- get_KGML("hsa04150")
#' 
#' # Some pathways contain only node information; since the purpose of this
#' # package is to explore pathways in an edge-focused manner, the default
#' # options return a warning message instead of a parsed KGML file if the 
#' # input pathway has no edges.
#' ribosome_KGML <- get_KGML("hsa03020") 
#' ribosome_KGML <- get_KGML("hsa03020", get_if_no_edges = TRUE) 
#' 

get_KGML <- 
function(pathwayid, get_if_no_edges = FALSE){
    tmp <-  suppressMessages(KEGGREST::keggGet(pathwayid, "kgml"))
    if(nchar(tmp) == 0){
        warning("Selected pathway does not have an associated KGML file")
        KGML_file <- NA
        return(KGML_file)
    }
    if(length(grep("relation",tmp)) == 0){
        if(get_if_no_edges){
            KGML_file <- KEGGgraph::parseKGML(tmp)
            return(KGML_file)
        }
        else {
            warning("Selected pathway does not contain any documented edges")
            return(NA)
        }
    }
    KGML_file <- KEGGgraph::parseKGML(tmp)
    return(KGML_file)
}

#' Combines all other package functions for one-step pathway visualization
#' @export
#' @param pathwayid A KEGG pathway ID of the form "hsa12345" 
#' (only human pathways currently)
#' @param cell_line If left as NA will generate a pathway map without 
#' data-dependent attributes (such as edge width).  To use in combination 
#' with LINCS data, choose from the set of cell lines: 
#' (A375,A549,ASC,HA1E,HCC515,HEK293T,HEKTE,HEPG2,HT29,MCF7,NCIH716,NPC,PC3,
#' SHSY5Y,SKL,SW480,VCAP)
#' @param refine_by_cell_line A logical indicator
#' @param add_L1000_edge_data A logical indicator 
#' @param data_type Choose from data types: (100_full, 100_bing, 50_lm)
#' @param pert_time Choose from (6,24,48,96,120,144,168)
#' @param only_mapped A logical indicator; if set to FALSE will return 'de-novo'
#' edges that 'exist' in data but are not documented in KEGG
#' @param significance_markup A logical indicator; if set to TRUE will color
#'  edges based on direction and significance of correlation (as determined by 
#'  user-data-analysis)
#' @param layered_nodes A logical indicator; if set to TRUE will create a graph 
#' with 'stacked' nodes that the user can manipulate when multiple nodes are 
#' mapped to one location
#' @param graph_title An optional user-specified graph title
#' @param get_data A logical indicator; if set to true, will return the 
#' 'expanded' edge information for the specified pathway
#' @param convert_KEGG_IDs A logical indicator; if set to TRUE KEGG 
#' compounds will remain labeled via KEGG codes (do not need KEGGREST)
#' @param tidy_edge A logical indicator; must be set to FALSE for expanded edges
#' @return  A dynamic map in Cytoscape automatically formatted for convenient 
#' viewing and, if idicated by user, a data.frame object with detailed 
#' information for 'expanded' KEGG edges
#' @examples \dontrun{ 
#' 
#' #Default KEGG pathway with colored edges representing type of relationship:
#' KEGG_lincs("hsa04115", convert_KEGG_IDs = FALSE)
#' 
#' #KEGG pathway with edge width and color based on observed experimental data:
#' KEGG_lincs("hsa04115", "HA1E")
#' 
#' #Have edge information data.frame to be output to the global environment:
#' p53_edge_info <- KEGG_lincs("hsa04115", graph_title = "p53"
#'                              convert_KEGG_IDs = FALSE, get_data = TRUE)
#'                              }


KEGG_lincs <-
function(pathwayid, cell_line = NA,
                            refine_by_cell_line = NA,
                            add_L1000_edge_data = TRUE,  
                            significance_markup = TRUE,
                            data_type = "100_full",
                            pert_time = 96,
                            only_mapped = TRUE,
                            layered_nodes = FALSE, graph_title = "default",
                            get_data = FALSE,
                            convert_KEGG_IDs = TRUE, 
                            tidy_edge = FALSE){
    if (is.na(refine_by_cell_line)){
        if (is.na(cell_line)){
            refine_by_cell_line <- FALSE
        }
        else {
            refine_by_cell_line <- TRUE
        }
    }

    KGML <- get_KGML(pathwayid, get_if_no_edges = TRUE)
    if(!isS4(KGML)){
        return()
    }
    if (!refine_by_cell_line){
        KEGG_mappings <- expand_KEGG_mappings(KGML,convert_KEGG_IDs = convert_KEGG_IDs)
    }
        
    if (refine_by_cell_line) {
        KEGG_mappings <- expand_KEGG_mappings(KGML,convert_KEGG_IDs = convert_KEGG_IDs)
        full_mappings <- KEGG_mappings
        KEGG_mappings <- refine_mappings(KEGG_mappings, cell_line)
        for (i in 1:nrow(full_mappings)){
            if(!full_mappings$entryID[i] %in% KEGG_mappings$entryID){
                full_mappings$BGcolor[i] <- "#d3d3d3"
                full_mappings$in_relationship <- 0
            }
        }
    }
    expanded_edges <- expand_KEGG_edges(KGML, KEGG_mappings)
    if(expanded_edges$type[1] == "dummy"){
        graph_title <- paste0("Pathway = ", pathwayid, ":", 
                        KGML@pathwayInfo@title, "Cell-Line: ", cell_line, 
                        "  *No Edges in Pathway")
    }

    if (is.na(cell_line)){
        edge_map <- edge_mapping_info(expanded_edges, tidy_edge = tidy_edge)
    if (graph_title == "default"){
        graph_title <- paste0("Pathway = ", pathwayid, ":", 
                            KGML@pathwayInfo@title)
        }
    }
    if (!is.na(cell_line) & !add_L1000_edge_data){
        edge_map <- edge_mapping_info(expanded_edges, tidy_edge = tidy_edge)
        if (graph_title == "default"){
            graph_title <- paste0("Pathway = ", pathwayid, ":", 
                            KGML@pathwayInfo@title, "Refined by Cell-Line:  ",
                            cell_line)
        }
    }
    if (nrow(expanded_edges[expanded_edges$type == "maplink",]) == 
        nrow(expanded_edges) & only_mapped) {
            edge_map <- edge_mapping_info(expanded_edges, tidy_edge = tidy_edge)
            if (graph_title == "default"){
                graph_title <- paste0("Pathway = ", pathwayid, ":", 
                            KGML@pathwayInfo@title, "Cell-Line: ", 
                            cell_line,  "  *No Edges in Data")
            }
        warning("All documented edges are of type 'maplink'; 
            Overlap data cannot be mapped to selected pathway")
    }
    if(!is.na(cell_line) & add_L1000_edge_data) {
        user_data <- overlap_info(KGML, KEGG_mappings, cell_line, 
                                data_type = data_type, pert_time = pert_time)
        if (!is.na(user_data)[1,1]) {
            edges_plus_data <- add_edge_data(expanded_edges, KEGG_mappings, 
                                            user_data, c(11,13),
                                            map_type = "SYMBOL", 
                                            only_mapped = only_mapped)
            edge_map <- edge_mapping_info(edges_plus_data, data_added = TRUE, 
                                    significance_markup = significance_markup,
                                    tidy_edge = tidy_edge)
            if (graph_title == "default"){
                graph_title <- paste0("Pathway = ", pathwayid, ":", 
                                KGML@pathwayInfo@title, ",  Cell-Line: ", 
                                cell_line, ",  Data type: ", data_type)
            }
        }
        else {
            edge_map <- edge_mapping_info(expanded_edges, tidy_edge = tidy_edge)
            if (graph_title == "default"){
                graph_title <- paste0("Pathway = ", pathwayid, ":", 
                                KGML@pathwayInfo@title, ",  Cell-Line: ", 
                                cell_line, "   *No Edges in Data")
            }
        }
    }
    if(refine_by_cell_line){
        node_map <- node_mapping_info(full_mappings)
    }
    else{
        node_map <- node_mapping_info(KEGG_mappings)
    }
    graph_object <- get_graph_object(node_map, edge_map, 
                                    layered_nodes = layered_nodes)
    cyto_vis(graph_object, title = graph_title)
    if(get_data){
        return(edge_map)
    }
}

#' Prepare nodes for mapping
#' @description Modify the mapping information for desired look when graphed 
#' in Cytoscape
#' @param KEGG_mappings The data.frame object generated by the function 
#' expand_KEGG_mappings()
#' @return A data.frame object for nodes that will be passed on to the function 
#' get_graph_object
#' @export
#' @examples
#' p53_KGML <- get_KGML("hsa04115")
#' p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML, FALSE)
#' 
#' p53_node_mapping_info <- node_mapping_info(p53_KEGG_mappings)

node_mapping_info <-
function(KEGG_mappings){
    node_map <- KEGG_mappings
    for (i in (1:nrow(node_map))){
        if (node_map$entryTYPE[i] == "compound" | 
            node_map$entryTYPE[i] == "group"){
            node_map$label_font_size[i] <- 6
        }
        else {
            node_map$label_font_size[i] <- 9
        }
        if (node_map$entryTYPE[i] == "compound"){
            node_map$border_width[i] <- 3
        }
        else if (node_map$entryTYPE[i] == "gene"){
            node_map$border_width[i] <- 1
        }
        else if (node_map$entryTYPE[i] == "group"){
            node_map$border_width[i] <- 3
        }
        else if (node_map$entryTYPE[i] == "map"){
        node_map$border_width[i] <- 1
        }
        else if (node_map$entryTYPE[i] == "ortholog"){
        node_map$border_width[i] <- 1
        }
        if (node_map$entryTYPE[i] == "map"){
            if (substring(node_map$LABEL[i],1,5) == "TITLE"){
                node_map$BGcolor[i] <- "#89b9cE"
                node_map$LABEL[i] <- strsplit(node_map$LABEL[[i]], ":")[[1]][2]
                node_map$shape[i] <- "rectangle"
                node_map$border_width[i] <- 3
                node_map$label_font_size[i] <- 11
            }
            else{
                node_map$BGcolor[i] <- "#b3dddf"
            }
        }
        if (node_map$entryTYPE[i] == "group"){
            node_map$width[i] <-node_map$width[i]+3
            node_map$height[i] <-node_map$height[i]+3
            node_map$entryNAMES[i] <- 
                toString(unlist(node_map$entrySYMBOL[[i]]))
            node_map$entrySYMBOL[i] <- 
                toString(unlist(node_map$entrySYMBOL[[i]]))
            node_map$entryACCESSION[i] <- 
                toString(unlist(node_map$entryACCESSION[[i]]))
        }
    }
    node_density <- data.frame(table(node_map$entryID), 
                            stringsAsFactors = FALSE)
    for (i in 1:nrow(node_map)){
        node_map$node_density[i] <- 
            node_density$Freq[node_density[,1] == node_map$entryID[i]]
    }
    return(node_map)
}

#' Prepare edges for mapping
#' @description Modify the mapping information for desired look when graphed in
#'  Cytoscape
#' @param expanded_edges The data frame object generated via the function 
#' expand_KEGG_edges() OR has been modified by the function add_edge_data()
#' @param data_added A logical indicator; must be set to TRUE if user data has
#'  been added (i.e. edges modified by function add_edge_data())
#' @param significance_markup A logical indicator; if set to TRUE will color 
#' edges based on direction and significance of correlation (as determined by 
#' user-data-analysis)
#' @param tidy_edge A logical indicator; must be set to FALSE for expanded edges
#' @return A data.frame object for edges that will be passed on to the function 
#' get_graph_object
#' @export
#' @examples
#' p53_KGML <- get_KGML("hsa04115")
#' p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML)
#' 
#' #Default; no data added to edges:
#' 
#' p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)
#' p53_edge_mapping_info <- edge_mapping_info(p53_edges) 
#' 
#' #If data is added to edges as additional attribute[s]:
#' 
#' p53_HA1E_data <- overlap_info(p53_KGML, p53_KEGG_mappings, 
#'                                "HA1E", data_type = "100_bing")
#' 
#' p53_edges_HA1E_data_MAPPED <- add_edge_data(p53_edges, p53_KEGG_mappings, 
#'                                             p53_HA1E_data, 
#'                                             data_column_no = c(3, 10,12),
#'                                             only_mapped = TRUE)
#'                                                
#' p53_edge_mapping_HA1E <- edge_mapping_info(p53_edges_HA1E_data_MAPPED, 
#'                                                       data_added = TRUE)
#'                                                       

edge_mapping_info <-
function(expanded_edges, data_added = FALSE, significance_markup = FALSE, 
         tidy_edge = TRUE){
    #expanded_edges <- expanded_edges[,-c(1)]
    for(i in 1:nrow(expanded_edges)){
        if (expanded_edges$subtype1[i] == "activation"){
            expanded_edges$color[i] = "#b20000"
        }
        else if (expanded_edges$subtype1[i] =="expression"){
            expanded_edges$color[i] = "#b20000"
        }
        else if (expanded_edges$subtype1[i] =="inhibition"){
            expanded_edges$color[i] = "#0015b2"
        } 
        else if (expanded_edges$subtype1[i] =="irreversible"){
          expanded_edges$color[i] = "#b20000"
        } 
        else if (expanded_edges$subtype1[i] =="repression"){
             expanded_edges$color[i] = "#0015b2"
        }
        else if (expanded_edges$subtype1[i] == "compound" | 
                    expanded_edges$subtype1[i] == "indirect_effect" | 
                    expanded_edges$subtype1[i] == "binding_association"){
             expanded_edges$color[i] = "#000000"
        }
        else if (expanded_edges$subtype1[i] == "de_novo") {
          expanded_edges$color[i] = "#808080"
        }
        else if (expanded_edges$subtype1[i] == "Not defined in KEGG" | 
                    expanded_edges$type[i] == "dummy") {
             expanded_edges$color[i] = "#808080"
        }
        else {
             expanded_edges$color[i] = "#1c9900"
        }
        
        if (expanded_edges$color[i] == "#1c9900"){
             expanded_edges$edge_label[i] = expanded_edges$value[i]
        }
        else {
             expanded_edges$edge_label[i] = NA
        }
    
        if (is.na(expanded_edges$subtype2[i]) == FALSE &  
            expanded_edges$subtype2[i] != "indirect"){
                if (expanded_edges$subtype1[i] == "inhibition"){
                    expanded_edges$color[i] = "#690099"
                }
                else if (expanded_edges$subtype1[i] == "activation"){
                    expanded_edges$color[i] = "#FF6600"
                }
            expanded_edges$edge_label[i] = expanded_edges$value2[i]
        }
        if(data_added){
            if (expanded_edges$premapped[i] == 1){
                if (expanded_edges$value[i] == "--|"){
                    expanded_edges$tooltip[i] <- 
                        paste0(expanded_edges$entry1symbol[i]," --| ", 
                                expanded_edges$entry2symbol[i])
                    }
                else {
                    expanded_edges$tooltip[i] <- 
                        paste0(expanded_edges$entry1symbol[i], " --> ", 
                                expanded_edges$entry2symbol[i])
                }
            }
          else {
            expanded_edges$tooltip[i] <- paste0(expanded_edges$entry1symbol[i],
                                                " - ",
                                                expanded_edges$entry2symbol[i])
            }
        }
        else {
            if (expanded_edges$value[i] == "--|"){
                expanded_edges$tooltip[i] <- 
                    paste0(expanded_edges$entry1symbol[i], " --| ",
                                                expanded_edges$entry2symbol[i])
                }
            else {
                expanded_edges$tooltip[i] <- 
                    paste0(expanded_edges$entry1symbol[i], " --> ", 
                                                expanded_edges$entry2symbol[i])
            }
        }
    }
    
    expanded_edges$name <- paste0(expanded_edges$entry1, 
                                " (", expanded_edges$type, ") ", 
                                expanded_edges$entry2)
    if (significance_markup){
        for (i in 1:nrow(expanded_edges)){
            if (expanded_edges$has_data[i] == 1){
                if (expanded_edges$summary_score[i] > 0 & 
                    expanded_edges$significant[i] == 1){
                        expanded_edges$color[i] <- "#b20000"
                        }
                else if (expanded_edges$summary_score[i] > 0 & 
                        expanded_edges$significant[i] == 0){
                        expanded_edges$color[i] <- "#FF6600"
                        }
                else if (expanded_edges$summary_score[i] <= 0 & 
                        expanded_edges$significant[i] == 1){
                        expanded_edges$color[i] <- "#0015b2"
                        }
                else {
                        expanded_edges$color[i] <- "#690099"
                }
            }
            else {
                expanded_edges$color[i] = "#808080"
            }
        }
    }
    #edge_map <- edge_map[,c(2,5,3,1,4:ncol(edge_map))]
    expanded_edges<- cbind(expanded_edges[,c("entry1", "entry2","edgeID", 
                                        "entry1accession", "entry2accession")],
                          expanded_edges[,c(6:ncol(expanded_edges))])
    expanded_edges <- expanded_edges[order(expanded_edges$edgeID),]

    if (tidy_edge == TRUE) {
      edge_IDs <- seq(min(expanded_edges$edgeID), max(expanded_edges$edgeID))
      for (i in edge_IDs[edge_IDs %in% expanded_edges$edgeID]){
        if(data_added == TRUE){
          expanded_edges <- tidy_edge(edges = expanded_edges,
                                      edge_id = edge_IDs[i], 
                                      data_added = TRUE,
                                      by_significance = TRUE)
        }
        if(data_added == FALSE){
          expanded_edges <- tidy_edge(edges = expanded_edges,
                                      edge_id = edge_IDs[i], 
                                      data_added = FALSE)
        }
      }
    }
    return(expanded_edges)
}

#' Generate graph object from nodes and edges
#' @description Obtain a graph object in the form of an igraph with 
#' KEGG-specific graphical information
#' @param node_mapping_info The data.frame object generated by the function 
#' node_mapping_info()
#' @param expanded_edges The data.frame object generated by the function 
#' edge_mapping_info()
#' @param layered_nodes A logical indicator; if set to TRUE will create a 
#' graph with 'stacked' nodes that the user can manipulate when multiple nodes 
#' are mapped to one location
#' @return A list object with the node and edge information from the graph 
#' required for mapping.
#' @export
#' @importFrom igraph V V<-
#' @examples
#' 
#' p53_KGML <- get_KGML("hsa04115")
#' p53_KEGG_mappings <-  expand_KEGG_mappings(p53_KGML)
#' 
#' p53_node_mapping_info <- node_mapping_info(p53_KEGG_mappings)
#' p53_edge_mapping_info <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)
#' 
#' #Default graph object will have 'expanded edges':
#' expanded_edges_graph_object <- get_graph_object(p53_node_mapping_info, 
#'                                                 p53_edge_mapping_info)
#' 
#' #Graph with layered nodes:
#' layered_nodes_graph_object <- get_graph_object(p53_node_mapping_info,
#'                                                p53_edge_mapping_info, 
#'                                                layered_nodes = TRUE)

get_graph_object <-
function(node_mapping_info, expanded_edges, layered_nodes = FALSE){
    NMI <- node_mapping_info
    if(!layered_nodes){
        edge_info <- expanded_edges
        GO <-  igraph::graph.data.frame(edge_info, directed = TRUE)
        GO <- GO + igraph::vertices(NMI$entryID[
        NMI$in_relationship == 0])
        GO <- GO + igraph::vertices(NMI$entryID[
        NMI$entryTYPE == "group"])

        V(GO)$entryNAMES <- NMI$entryNAMES[match(V(GO)$name,NMI$entryID)]
        V(GO)$entryTYPE <- NMI$entryTYPE[match(V(GO)$name,NMI$entryID)]
        V(GO)$FGcolor <- NMI$FGcolor[match(V(GO)$name,NMI$entryID)]
        V(GO)$BGcolor <- NMI$BGcolor[match(V(GO)$name,NMI$entryID)]
        V(GO)$Xcoord <- NMI$Xcoord[match(V(GO)$name,NMI$entryID)]
        V(GO)$Ycoord <- NMI$Ycoord[match(V(GO)$name,NMI$entryID)]
        V(GO)$shape <- NMI$shape[match(V(GO)$name,NMI$entryID)]
        V(GO)$width <- NMI$width[match(V(GO)$name,NMI$entryID)]
        V(GO)$height <- NMI$height[match(V(GO)$name,NMI$entryID)]
        V(GO)$entryACCNUM <- NMI$entryACCESSION[match(V(GO)$name,NMI$entryID)]
        V(GO)$LABEL <- NMI$LABEL[match(V(GO)$name,NMI$entryID)]
        V(GO)$border_width <- NMI$border_width[match(V(GO)$name,NMI$entryID)]
        V(GO)$label_font_size <- 
            NMI$label_font_size[match(V(GO)$name,NMI$entryID)]
        return(GO)
    }
    else {
        refcols <- c("entry1symbol", "entry2symbol")
        edge_info <- expanded_edges[,c(refcols, 
                                   setdiff(names(expanded_edges), refcols))]
        GO <- igraph::graph.data.frame(edge_info, directed = TRUE)
        GO <- GO + igraph::vertices(NMI$entrySYMBOL[NMI$in_relationship == 0])
        V(GO)$entryNAMES <- NMI$entryNAMES[match(V(GO)$name,NMI$entrySYMBOL)]
        V(GO)$entryTYPE <- NMI$entryTYPE[match(V(GO)$name,NMI$entrySYMBOL)]
        V(GO)$FGcolor <- NMI$FGcolor[match(V(GO)$name,NMI$entrySYMBOL)]
        V(GO)$BGcolor <- NMI$BGcolor[match(V(GO)$name,NMI$entrySYMBOL)]
        V(GO)$Xcoord <- NMI$Xcoord[match(V(GO)$name,NMI$entrySYMBOL)]
        V(GO)$Ycoord <- NMI$Ycoord[match(V(GO)$name,NMI$entrySYMBOL)]
        V(GO)$shape <- NMI$shape[match(V(GO)$name,NMI$entrySYMBOL)]
        V(GO)$width <- NMI$width[match(V(GO)$name,NMI$entrySYMBOL)]
        V(GO)$height <- NMI$height[match(V(GO)$name,NMI$entrySYMBOL)]
        V(GO)$entryACCNUM <- 
            NMI$entryACCESSION[match(V(GO)$name,NMI$entrySYMBOL)]
        V(GO)$LABEL <- NMI$entrySYMBOL[match(V(GO)$name,NMI$entrySYMBOL)]
        V(GO)$border_width <- 
            NMI$border_width[match(V(GO)$name,NMI$entrySYMBOL)]
        V(GO)$label_font_size <- 
            NMI$label_font_size[match(V(GO)$name,NMI$entrySYMBOL)]
    
        return(GO)
    }
}

#' The 'boilerplate' for this package's desired graph style 
#' @description Generates an object that can be converted to a JSON file 
#' and subsequently applied to the graph for the markup specified by this
#'  package and the layout mirroring KEGG.
#' Intended for use within \code{\link{cyto_vis}}
#' @export
#' @param style_name An argument to name style; when used inside 
#' of \code{\link{cyto_vis}} no name is needed
#' @param map_edge_width A logical indicator; if FALSE no continuous mapping 
#' of edge width will be applied
#' @param edge_width_attribute The attribute that will be used for edge width; 
#' if data is not added or the attribute is not part of the graphing 
#' information, the edge width will default to 1. 
#' @param min_score The minimum attribute value for the column used to map 
#' edge width
#' @param max_score The maximum attribute value for the column used to map 
#' edge width
#' @return A list that can be converted to a JSON file to apply desired 
#' style/layout in Cytoscape  
#' @examples 
#' style.name = "myKEGGstyle"
#' mappings <- generate_mappings(style.name, FALSE)

generate_mappings <-
function(style_name, map_edge_width, edge_width_attribute, 
            min_score, max_score){
    style.name = style_name
    
    # Visual Mappings
    #######
    ##defaults
    def.node.font <- list(visualProperty = "NODE_LABEL_FONT_FACE", 
                            value = "TeXGyrePagella-Regular")
    
    defaults <- list(def.node.font)
    #######
    
    ####transparency
    pair1a = list(key = "group",value = "0")
    pair1b = list(key = "gene", value = "150")
    pair1c = list(key = "compound", value = "255")
    pair1d = list(key = "map",value = "255")
    discrete.mappings.1 = list(pair1a, pair1b, pair1c, pair1d)
    ####node shape
    pair2a = list(key = "circle", value = "Ellipse")
    pair2b = list(key = "roundrectangle", value = "Round_Rectangle")
    pair2c = list(key = "rectangle",  value = "Rectangle")
    discrete.mappings.2 = list(pair2a, pair2b, pair2c)
    ###edge target arrow shape
    pair3a = list(key = "activation", value = "Delta")
    pair3b = list(key = "expression", value = "Arrow")
    pair3c = list(key = "indirect_effect", value = "Diamond")
    pair3d = list(key = "inhibition",  value = "T")
    pair3e = list(key = "inhibition_phosphorylation",  value = "T")
    pair3f = list(key = "irreversible",  value = "Arrow")
    pair3g = list(key = "phosphorylation",  value = "Diamond")
    pair3h = list(key = "repression",  value = "T")
    discrete.mappings.3 = list(pair3a, pair3b, pair3c, pair3d, pair3e, pair3f, 
                                pair3g, pair3h)
###node label location
    pair4a = list(key = "compound", value = "S,N,c,0.0,0.0")
    pair4b = list(key = "group",  value = "E,W,c,2.0,0.0")
    discrete.mappings.4 = list(pair4a, pair4b)
###dashed edge for indirect effects
    pair5 = list(key = "0.0",  value = "Equal_Dash")
    discrete.mappings.5 = list(pair5)
###transparancy for edges [based on existence in data : 
###    not needed for 'default' graphs]
    pair6a = list(key = "0.0",value = "100")
    pair6b = list(key = "1.0", value = "255")
    discrete.mappings.6 = list(pair6a, pair6b)
    
    node.transparency = list(mappingType="discrete",
                                mappingColumn="entryTYPE",
                                mappingColumnType="String",
                                visualProperty="NODE_TRANSPARENCY",
                                map = discrete.mappings.1)
    node.shape = list(mappingType="discrete", 
                         mappingColumn="shape",
                         mappingColumnType="String",
                          visualProperty="NODE_SHAPE",
                         map = discrete.mappings.2)
    node.label.position = list(mappingType="discrete",
                               mappingColumn="entryTYPE",
                               mappingColumnType="String",
                               visualProperty="NODE_LABEL_POSITION",
                               map = discrete.mappings.4)
    node.color = list(mappingType="passthrough",
                        mappingColumn="BGcolor",
                        mappingColumnType="String",
                        visualProperty="NODE_FILL_COLOR")
    node.label = list(mappingType="passthrough",
                        mappingColumn="LABEL",
                        mappingColumnType="String",
                        visualProperty="NODE_LABEL")
    node.label.width = list(mappingType="passthrough",
                        mappingColumn="width",
                        mappingColumnType="String",
                        visualProperty="NODE_LABEL_WIDTH")
    node.Xcoord = list(mappingType="passthrough",
                       mappingColumn="Xcoord",
                       mappingColumnType="Double",
                       visualProperty="NODE_X_LOCATION")
    node.Ycoord = list(mappingType="passthrough",
                        mappingColumn="Ycoord",
                        mappingColumnType="Double",
                        visualProperty="NODE_Y_LOCATION")
    node.width = list(mappingType="passthrough",
                        mappingColumn="width",
                        mappingColumnType="Double",
                        visualProperty="NODE_WIDTH")
    node.height = list(mappingType="passthrough",
                        mappingColumn="height",
                        mappingColumnType="Double",
                        visualProperty="NODE_HEIGHT")
    node.border.width = list(mappingType="passthrough",
                                mappingColumn="border_width",
                                mappingColumnType="Double",
                                visualProperty="NODE_BORDER_WIDTH")
    node.label.font.size = list(mappingType="passthrough",
                                mappingColumn="label_font_size",
                                mappingColumnType="Double",
                                visualProperty="NODE_LABEL_FONT_SIZE")
    node.tooltip = list(mappingType="passthrough",
                        mappingColumn="entryNAMES",
                        mappingColumnType="String",
                        visualProperty="NODE_TOOLTIP")
    node.mappings = list(node.color, node.label, node.label.width, 
                        node.label.position, node.border.width,node.Xcoord, 
                        node.Ycoord, node.width, node.height, 
                        node.transparency, node.shape, node.label.font.size, 
                        node.tooltip)
    edge.target.arrow.shape = list(mappingType="discrete",
                                    mappingColumn="subtype1", 
                                    mappingColumnType="String",
                                    visualProperty="EDGE_TARGET_ARROW_SHAPE",
                                    map = discrete.mappings.3)
    edge.line.type = list(mappingType="discrete",
                            mappingColumn="is_direct",
                            mappingColumnType="Double",
                            visualProperty="EDGE_LINE_TYPE",
                            map = discrete.mappings.5)
    edge.transparency = list(mappingType="discrete",
                                mappingColumn="has_data",
                                mappingColumnType="Double",
                                visualProperty="EDGE_TRANSPARENCY",
                                map = discrete.mappings.6)
    edge.target.arrow.color = list(mappingType="passthrough",
                                    mappingColumn="color",
                                    mappingColumnType="String",
                                    visualProperty=
                                    "EDGE_TARGET_ARROW_UNSELECTED_PAINT")
    edge.label = list(mappingType="passthrough",
                        mappingColumn="edge_label",
                        mappingColumnType="String",
                        visualProperty="EDGE_LABEL")
    edge.color = list(mappingType="passthrough",
                        mappingColumn="color",
                        mappingColumnType="String",
                        visualProperty="EDGE_STROKE_UNSELECTED_PAINT")
    edge.tooltip = list(mappingType="passthrough",
                        mappingColumn="tooltip",
                        mappingColumnType="String",
                        visualProperty="EDGE_TOOLTIP")
    
    if (map_edge_width){
        point1 = list(value=min_score, lesser= "1", equal="1", greater="1")
        point2 = list(value=max_score, lesser="20", equal="20", greater="20")
        edge.width.continuous.points = list(point1, point2)
        edge.width = list(mappingType="continuous",
                            mappingColumn = edge_width_attribute,
                            mappingColumnType="Double",
                            visualProperty="EDGE_WIDTH",
                            points = edge.width.continuous.points)
        edge.mappings = list(edge.target.arrow.color, edge.target.arrow.shape, 
                            edge.line.type, edge.color, edge.tooltip, 
                            edge.label, edge.transparency, edge.width)
    }
    else {
        edge.mappings = list(edge.target.arrow.color, edge.target.arrow.shape, 
                            edge.line.type, edge.color,
                            edge.tooltip, edge.label)
    }
    mappings <- c(node.mappings, edge.mappings)
    return(list(defaults,mappings))
}

#' Get detailed KEGG mapping information for each relation [edge] documented 
#' in KEGG
#' @description Extract relationship information from KGML object and re-map
#'  based on normalized node information
#'
#' @param KGML_file An object of formal class KEGGPathway
#' @param KEGG_mappings The data.frame object generated by the function 
#' expand_KEGG_mappings
#'
#' @return A dataframe object with unique entry information for all edges 
#' documented in the KEGG pathway. 
#'         Note that each row has a unique combination of values for
#'          (entry1, entry2, entry1symbol, entry2symbol).
#' @export
#' @importMethodsFrom KEGGgraph edges
#' @examples
#' p53_KGML <- get_KGML("hsa04115")
#' p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML, FALSE)
#' p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)


expand_KEGG_edges <-
function(KGML_file,KEGG_mappings){
    num_edges <- length(KGML_file@edges)
    if (num_edges == 0){
        print("No Documented Edges in Pathway")
        expanded_edges <- data.frame("edgeID"=1, "entry1"= "1", "entry2" = "1",
                                    "entry1accession"="dummy",  "
                                    entry2accession"="dummy",
                                    "type"= "dummy", "subtype1"="dummy",       
                                    "value"="dummy", "subtype2" = "dummy", 
                                    "value2" = "dummy", 
                                    "specific_subtype"="dummy", 
                                    "is_direct"= 0, "entry1type"="dummy",     
                                    "entry2type"= "dummy", "entry1symbol"= "1",
                                    "entry2symbol"="1", 
                                    stringsAsFactors = FALSE) 
    return(expanded_edges)
    }
    map_edge_data<- KGML_file@edges
    get_edges<- data.frame(edgeID = seq(1:length(map_edge_data )))
    for (i in 1:nrow(get_edges)){
        get_edges$entry1[i] <- as.numeric(map_edge_data[[i]]@entry1ID)
        get_edges$entry2[i] <- as.numeric(map_edge_data[[i]]@entry2ID)
        get_edges$type[i] <- map_edge_data[[i]]@type
        if (length(map_edge_data[[i]]@subtype) == 1){
            get_edges$subtype1[i] <- map_edge_data[[i]]@subtype[[1]]@name
            if (get_edges$subtype1[i] == "binding/association"){
                get_edges$subtype1[i] <- "binding_association"
                }
            get_edges$value[i] <- map_edge_data[[i]]@subtype[[1]]@value
            get_edges$subtype2[i] <- NA
            get_edges$value2[i] <- NA
            get_edges$specific_subtype[i] <- get_edges$subtype1[i]
            get_edges$is_direct[i] <- 1
            if (get_edges$subtype1[i] == "indirect effect"){
                get_edges$is_direct[i] <- 0
                get_edges$subtype1[i] <- "indirect_effect"
            }
        }
        else if (length(map_edge_data[[i]]@subtype) == 2){
            get_edges$subtype1[i] <- map_edge_data[[i]]@subtype[[1]]@name
                if (get_edges$subtype1[i] == "binding/association"){
                    get_edges$subtype1[i] <- "binding_association"
                    }
            get_edges$value[i] <- map_edge_data[[i]]@subtype[[1]]@value
            get_edges$subtype2[i] <- map_edge_data[[i]]@subtype[[2]]@name
            get_edges$specific_subtype[i] <- paste0(get_edges$subtype1[i], "_",
                                                    get_edges$subtype2[i])
            get_edges$value2[i] <- map_edge_data[[i]]@subtype[[2]]@value
            get_edges$is_direct[i] <- 1
            if (get_edges$subtype2[i] == "indirect effect"){
                get_edges$subtype2[i] <- "indirect"
                get_edges$is_direct[i] <- 0
            }
        }
        else {
            get_edges$subtype1[i] <- "Not defined in KEGG"
            get_edges$value[i] <- "Not defined in KEGG"
            get_edges$subtype2[i] <- NA
            get_edges$value2[i] <- NA
            get_edges$specific_subtype[i] <- NA
            get_edges$is_direct[i] <- 1
        }
        get_edges$entry1type[i] <- 
            KEGG_mappings$entryTYPE[which(KEGG_mappings$entryID == 
                                         get_edges$entry1[i])][1]
        get_edges$entry2type[i] <- 
            KEGG_mappings$entryTYPE[which(KEGG_mappings$entryID == 
                                         get_edges$entry2[i])][1]
    }
    get_edges <- get_edges[!is.na(get_edges$entry1type) & 
                            !is.na(get_edges$entry2type),]
    if (nrow(get_edges) ==0){
        print("No Documented Edges in Pathway for selected cell type; 
            all edges are between non-expressed genes")
        expanded_edges <- data.frame("edgeID"=1, "entry1"= "1", "entry2" = "1",
                                     "entry1accession"="dummy",  
                                    "entry2accession"="dummy","type"= "dummy", 
                                    "subtype1"="dummy", "value"="dummy", 
                                    "subtype2" = "dummy", "value2" = "dummy",
                                    "specific_subtype"="dummy", "is_direct"= 0,
                                    "entry1type"="dummy", 
                                    "entry2type"= "dummy","entry1symbol"= "1",
                                    "entry2symbol"="1", 
                                    stringsAsFactors = FALSE)
        return(expanded_edges)
    }

  ##At some point include option not to ungroup edges
    edges_no_groups <- subset(get_edges, get_edges$entry1type != "group" 
                            & get_edges$entry2type != "group", select = -c(1))
    edges_with_groups <- subset(get_edges, get_edges$entry1type == "group" | 
                                get_edges$entry2type == "group")
    edges_one_group <- subset(get_edges, get_edges$entry1type == "group" & 
                                !get_edges$entry2type == "group" | 
                                get_edges$entry2type == "group" & 
                                !get_edges$entry1type == "group")
    edges_two_groups <- subset(get_edges, get_edges$entry1type == "group" & 
                                get_edges$entry2type == "group")
    if (nrow(edges_with_groups) > 0){
        if (nrow(edges_one_group) > 0){
            edges_one_group$entry1all <- NA
            edges_one_group$entry2all <- NA
            for (i in 1:nrow(edges_one_group)){
                if (edges_one_group$entry1type[i] == "group"){
                    edges_one_group$entry1all[i] <-  
                    KEGG_mappings$groupMEMBERS[which(KEGG_mappings$entryID == 
                                                edges_one_group$entry1[i])]
                    l <- length(unlist(edges_one_group$entry1all[i]))
                    edges_one_group$entry2all[i] <- 
                        list(as.character(rep(edges_one_group$entry2[i], l)))
                    }
                else if (edges_one_group$entry2type[i] == "group"){
                    edges_one_group$entry2all[i] <-  
                    KEGG_mappings$groupMEMBERS[which(KEGG_mappings$entryID == 
                                                edges_one_group$entry2[i])]
                    l = length(unlist(edges_one_group$entry2all[i]))
                    edges_one_group$entry1all[i] <- 
                        list(as.character(rep(edges_one_group$entry1[i], l)))
                    }
            l = length(unlist(edges_one_group$entry1all[i]))
            edges_one_group$edgeID_list[i] <- 
                list(rep(edges_one_group$edgeID[i],l))
            }
            ewg_temp <- data.frame("edgeID" = 
                                        unlist(edges_one_group$edgeID_list), 
                            "entry1" = unlist(edges_one_group$entry1all), 
                            "entry2" = unlist(edges_one_group$entry2all),
                            stringsAsFactors = FALSE)
            edges_one_group <- edges_one_group[,-c(2:3, 13:15)]
            edges_one_group <- merge(ewg_temp,edges_one_group, by = "edgeID")
            edges_one_group <- edges_one_group[,-c(1)]
        }
        if (nrow(edges_two_groups) > 0){
            edges_two_groups$entry1all <- NA
            edges_two_groups$entry2all <- NA
                for (i in 1:nrow(edges_two_groups)){
                    edges_two_groups$entry1all[i] <-  
                    KEGG_mappings$groupMEMBERS[which(KEGG_mappings$entryID == 
                                                edges_two_groups$entry1[i])]
                    edges_two_groups$entry2all[i] <-  
                    KEGG_mappings$groupMEMBERS[which(KEGG_mappings$entryID == 
                                                edges_two_groups$entry2[i])]
                    x <- length(unlist(edges_two_groups$entry1all[i]))
                    y <- length(unlist(edges_two_groups$entry2all[i]))
                    if (x == 1 & y >1){
                        edges_two_groups$entry1all[i] <- 
                            list(rep(edges_two_groups$entry1all[i], y))
                        }
                    else if (x > 1 & y == 1){
                        edges_two_groups$entry2all[i] <- 
                            list(rep(edges_two_groups$entry2all[i], x))
                        }
                    else if (x > 1 & y > 1){
                        edges_two_groups$entry1all[i] <- 
                            list(rep(edges_two_groups$entry1all[i],y))
                        edges_two_groups$entry1all[i] <- 
                            list(unlist(edges_two_groups$entry1all[i])[
                            sort.list(unlist(edges_two_groups$entry1all[i]))])
                        edges_two_groups$entry2all[i] <- 
                            list(rep(edges_two_groups$entry2all[i],x))
                    }
                    l <- length(unlist(edges_two_groups$entry1all[i]))
                    edges_two_groups$edgeID_list[i] <- 
                        list(rep(edges_two_groups$edgeID[i],l))
                    }
            ewg_temp <- data.frame("edgeID" = 
                                    unlist(edges_two_groups$edgeID_list),
                                "entry1" = unlist(edges_two_groups$entry1all), 
                                "entry2" = unlist(edges_two_groups$entry2all), 
                                stringsAsFactors = FALSE)
            edges_two_groups <- edges_two_groups[,-c(2:3, 13:15)]
            edges_two_groups <- merge(ewg_temp,edges_two_groups, by = "edgeID")
            edges_two_groups <- edges_two_groups[,-c(1)]
        }
        if (nrow(edges_one_group) > 0 & nrow(edges_two_groups) > 0){
            all_edges <- rbind(edges_no_groups, edges_one_group, 
                                edges_two_groups)
        }
        else if (nrow(edges_one_group) > 0){
            all_edges <- rbind(edges_no_groups, edges_one_group)
        }
        else if (nrow(edges_two_groups) > 0){
             all_edges <- rbind(edges_no_groups, edges_two_groups)
        }
    }
    else {
        all_edges <- edges_no_groups
    }
    for (i in 1:nrow(all_edges)){
        all_edges$entry1all_accession[i] <- 
            list(KEGG_mappings$entryACCESSION[which(KEGG_mappings$entryID == 
                                                all_edges$entry1[i])])
        all_edges$entry2all_accession[i] <- 
            list(KEGG_mappings$entryACCESSION[which(KEGG_mappings$entryID ==
                                                all_edges$entry2[i])])
        x <- length(unlist(all_edges$entry1all_accession[i]))
        y <- length(unlist(all_edges$entry2all_accession[i]))
        if (x == 1 & y >1){
            all_edges$entry1all_accession[i] <- 
                list(rep(all_edges$entry1all_accession[i], y))
            }
        else if (x > 1 & y == 1) {
            all_edges$entry2all_accession[i] <- 
                list(rep(all_edges$entry2all_accession[i], x))
        }
        else if (x > 1 & y > 1) {
            all_edges$entry1all_accession[i] <-
                list(rep(all_edges$entry1all_accession[i],y))
            all_edges$entry1all_accession[i] <- 
                list(unlist(all_edges$entry1all_accession[i])[sort.list(unlist(
                    all_edges$entry1all_accession[i]))])
            all_edges$entry2all_accession[i] <- 
                list(rep(all_edges$entry2all_accession[i],x))
            }
        l <- length(unlist(all_edges$entry1all_accession[i]))
        all_edges$edgeID[i] = list(rep(i,l))
    }
    for (i in 1:nrow(all_edges)){
        all_edges$l1[i] <- length(all_edges$entry1all_accession[[i]])
        all_edges$l2[i] <- length(all_edges$entry2all_accession[[i]])
    }
    all_edges <- all_edges[all_edges$l1 >0 & all_edges$l2 > 0, -c(15,16)]
    expanded_edges <- data.frame("edgeID" = unlist(all_edges$edgeID), 
                            "entry1accession" = 
                                unlist(all_edges$entry1all_accession), 
                            "entry2accession" =
                                unlist(all_edges$entry2all_accession), 
                            stringsAsFactors = FALSE)
  
    all_edges <- all_edges[,-c(12:14)]
    all_edges$edgeID <- seq(1:nrow(all_edges))
    expanded_edges <- merge(expanded_edges, all_edges, by = "edgeID")
    for (i in 1:nrow(expanded_edges)){
        expanded_edges$entry1type[i] <- 
            KEGG_mappings$entryTYPE[which(KEGG_mappings$entryID == 
                                      expanded_edges$entry1[i])][1]
        expanded_edges$entry2type[i] <- 
            KEGG_mappings$entryTYPE[which(KEGG_mappings$entryID ==
                                      expanded_edges$entry2[i])][1]
        if (expanded_edges$entry1type[i] == "gene"|
            expanded_edges$entry1type[i] == "compound") {
            expanded_edges$entry1symbol[i] <- 
            KEGG_mappings$entrySYMBOL[which(KEGG_mappings$entryACCESSION == 
                                        expanded_edges$entry1accession[i])][1]
            }
        else {
            expanded_edges$entry1symbol[i] <- NA
        }
        if (expanded_edges$entry2type[i] == "gene" |
            expanded_edges$entry2type[i] == "compound") {
            expanded_edges$entry2symbol[i] <- 
            KEGG_mappings$entrySYMBOL[which(KEGG_mappings$entryACCESSION == 
                                        expanded_edges$entry2accession[i])][1]
        }
        else {
            expanded_edges$entry2symbol[i] <- NA
        }
    }
    expanded_edges$entry1symbol <- unlist(expanded_edges$entry1symbol)
    expanded_edges$entry2symbol <- unlist(expanded_edges$entry2symbol)
    expanded_edges$is_direct <- as.numeric(expanded_edges$is_direct)
    return(expanded_edges)
}

#' Perform Fisher's Exact test for edges in pathway
#' @description Obtain a measure for strength and significance for the 
#' relationship (i.e. an edge) based on the concordance/discordance of 
#' UP-and-DOWN regulated genes shared by two different experimental 
#' gene-knockouts
#' Intended for use within \code{\link{overlap_info}}
#' @export
#' @importFrom stats fisher.test p.adjust p.adjust.methods
#' @param edges The set of eges to be analyzed; Although the intended use is for
#' LINCS data overlaps, the function should work with any typical data object as
#' long as it has columns labeled ("UP", "DOWN", "UK1_DK2", "DK1_UK2") that 
#' contain integer values.
#' @param method The method to correct/adjust p-values for multiple testing. 
#' For available methods, type 'p.adjust.methods' into command promt and 
#' press enter.
#' @return The input edge data.frame object with additional columns containing
#' the results of the applied statistical test  
#' @examples
#' ex.data <- data.frame("UP" = c(70,6), "DOWN" = c(8,20),
#'                     "UK1_DK2" = c(4,47), "DK1_UK2" = c(3, 28))
#' 
#' overlaps <- get_fisher_info(ex.data, method = "BH")

get_fisher_info <-
function(edges, method){
    if (!method %in% p.adjust.methods){
        warning("Method for p-value adjustment is not valid. For valid 
                adjustment methods please type 'p.adjust.methods' in the 
                command line and press enter. P-values will not be adjusted")
        method = "none"
    }
    for (i in 1:nrow(edges)){
        fisher_test<- fisher.test(matrix(c(edges$UP[i] + 1,edges$UK1_DK2[i] + 1,
                                edges$DK1_UK2[i] + 1 ,edges$DOWN[i] + 1), 2,2))
        edges$fisher_OR[i] <- unlist(fisher_test[[3]])
        edges$fisher_pval[i] <- unlist(fisher_test[[1]])
        if (edges$fisher_OR[i] <= 1) {
            edges$fisher_sign[i] <- -1
        }
        else {
            edges$fisher_sign[i] <- 1
        }
        edges$summary_score[i] <- 
            -log(edges$fisher_pval[i])*edges$fisher_sign[i]
    }
    raw_pvals <- edges$fisher_pval
    adj_pvals <- p.adjust(raw_pvals, method = method)
    edges$p_value <-  adj_pvals
    for (i in 1:nrow(edges)){
        if (edges$p_value[i] <= 0.05){
            edges$significant[i] <- 1
        }
        else {
            edges$significant[i] <- 0
        }
    }
    return(edges)
}

#' Send graph to Cytoscape via CyREST
#' @description View the KEGG pathway in Cytoscape. With either the 
#' 'expanded edges' or 'stacked nodes' layout, users can visualize and interact 
#' with the graphs [strictly] as they are documented in the most recent KGML
#' available from KEGG.  
#' This function is a modified version of the function send2cy(),
#'  which is part of the cyREST utility functions.
#' @export
#' @import methods
#' @import httr
#' @import RJSONIO
#' @param graph_object An igraph object such as the one generated by the 
#' function \code{\link{get_graph_object}}
#' @param title An optional title for the graph when it is in Cytoscape
#' @param edge_width_attribute The attribute that will be used for edge width; 
#' if data is not added or the attribute is not part of the graphing 
#' information, the edge width will default to 1. 
#' @param port.number The port address for Cytoscape 
#' @return A dynamic map in Cytoscape automatically formatted for convenient 
#' viewing.  
#' @examples 
#' p53_KGML <- get_KGML("hsa04115")
#' p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML, FALSE)
#' nodes <- node_mapping_info(p53_KEGG_mappings)
#' 
#' p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)
#' edges <- edge_mapping_info(p53_edges) 
#' 
#' p53_graph_object <- get_graph_object(nodes, edges)
#'                                       
#' @examples \dontrun{
#' cyto_vis(p53_graph_object, "Default p53 Graph [no data added]")
#' 
#' #Workflow to visualize graph with data-dependent attributes:
#' 
#' p53_KGML <- get_KGML("hsa04115")
#' p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML)
#' nodes <- node_mapping_info(p53_KEGG_mappings)
#' 
#' p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)
#' 
#' p53_HA1E_data <- overlap_info(p53_KGML, p53_KEGG_mappings, "HA1E", 
#'                                data_type = "100_bing")
#' p53_edges_plus_data <- add_edge_data(p53_edges, p53_KEGG_mappings, 
#'                                       p53_HA1E_data, c(3, 10,12),
#'                                       only_mapped = TRUE)
#' 
#' edges <- edge_mapping_info(p53_edges_plus_data, data_added = TRUE)
#'                                             
#' p53_plus_data_graph_object <- get_graph_object(nodes, edges)
#'                                                 
#' cyto_vis(p53_plus_data_graph_object, "p53 Graph: Mapped Edges + HA1E Data",
#'          edge_width_attribute = "UP")
#'          }

cyto_vis <-
    function(graph_object, title = "Cytoscape Graph Window",
            edge_width_attribute = "summary_score",
            port.number = 1234) {
    base.url = paste("http://localhost:", toString(port.number), "/v1", sep="")

    if (edge_width_attribute %in% names(igraph::edge_attr(graph_object))){
        min.summary_score <- min(abs(igraph::E(graph_object)$summary_score),
                                na.rm = TRUE)
        max.summary_score <- max(abs(igraph::E(graph_object)$summary_score), 
                                na.rm = TRUE)
        map_edge_width <- TRUE
    }
    else {
        min.summary_score <- NA
        max.summary_score <- NA
        map_edge_width <- FALSE
    }
    
    graph_object$name <- title
    cygraph <- toCytoscape(graph_object)
        
    network.url = paste(base.url, "networks", sep="/")
    res <- httr::POST(url=network.url, body=cygraph, encode="json")
    network.suid = unname(RJSONIO::fromJSON(rawToChar(res$content)))
    
    style.name = "myKEGGstyle"
    mappings <- generate_mappings(style.name, map_edge_width, 
                                    edge_width_attribute, 
                                    min_score = min.summary_score, 
                                    max_score = max.summary_score)
    style.url = paste(base.url, "styles", sep="/")
    style <- list(title=style.name, defaults = mappings[[1]],
                  mappings = mappings[[2]])
    style.JSON <- RJSONIO::toJSON(style)
    httr::POST(url=style.url, body=style.JSON, encode = "json")
    
    dependencies.url <- paste(style.url, style.name, "dependencies", sep="/")
    lock_style <- list(visualPropertyDependency="nodeSizeLocked", 
                       enabled = "false")
    lock_style.JSON <- toJSON(list(lock_style))
    PUT(url=dependencies.url, body=lock_style.JSON, encode="json")
    
    apply.style.url = paste(base.url, "apply/styles", style.name ,
                            toString(network.suid), sep="/")
    httr::GET(apply.style.url)
    
    fit_content.url <- paste(base.url, "apply/fit", network.suid, sep="/")
    httr::GET(url=fit_content.url)
    }

#' Add in edges to map documented in other pathways
#' @description For a specific pathway entity(gene), search KEGG databases
#' to see if it has any other documented relationships in KEGG.
#' expand_KEGG_edges 
#' @export
#' @param entry_accession The Accession # of the pathway entity to 'keggerize'
#' @param KGML The KGML file of the current pathway
#' @param KEGG_mappings KEGG mappings for the current pathway
#' @param edges The expanded edges for the current pathway
#' @return A modified expanded edges data frame with additional rows for new 
#' entries
#' @examples \dontrun{
#' KGML <- get_KGML("hsa04150")
#' KEGG_mappings <- expand_KEGG_mappings(KGML)
#' edges <- expand_KEGG_edges(KGML, KEGG_mappings)
#' entry_accession <- "2475"
#' mtor_plus_mtor <- keggerize_edges(entry_accession = entry_accession, 
#'                                   KGML = KGML,KEGG_mappings = KEGG_mappings,
#'                                   edges = edges) }
#' 

keggerize_edges <- function(entry_accession, KGML, KEGG_mappings, edges){
    if(!"primary_pathway" %in% names(edges)){
        edges$primary_pathwayID <- strsplit(KGML@pathwayInfo@name, ":")[[1]][2]
        edges$primary_pathway <- KGML@pathwayInfo@title
    }
    entry_code <- paste0("hsa:",entry_accession)
    entry_info <- keggGet(entry_code)
    entry_pathways <- entry_info[[1]]["PATHWAY"]
    entry_pathways <- names(entry_pathways$PATHWAY[1:length(unlist(entry_pathways))])
    current_pathway <- strsplit(KGML@pathwayInfo@name, ":")[[1]][2]
    entry_pathways <- entry_pathways[!entry_pathways %in% current_pathway]
    
    for(p in 1:length(entry_pathways)){
        pathway_KGML <- get_KGML(entry_pathways[p])
        pathway_KEGG_mappings <- expand_KEGG_mappings(pathway_KGML)
        pathway_edges <- expand_KEGG_edges(pathway_KGML, pathway_KEGG_mappings)
        entry_edges <- pathway_edges[pathway_edges$entry1accession == entry_accession |
                                         pathway_edges$entry2accession == entry_accession, ]
        entry_sources <- entry_edges[entry_edges$entry1accession != entry_accession &
                                         entry_edges$entry1accession %in% KEGG_mappings$entryACCESSION,]
        entry_sources <- entry_sources[!duplicated(entry_sources[,6:16]),]
        if(nrow(entry_sources) > 0){
            for(i in 1:nrow(entry_sources)){
                entry1_locations <- KEGG_mappings$entryID[KEGG_mappings$entrySYMBOL == entry_sources$entry1symbol[i]]
                entry2_locations <- KEGG_mappings$entryID[KEGG_mappings$entrySYMBOL == entry_sources$entry2symbol[i]]
                if(length(entry1_locations) > 1 | length(entry2_locations > 1)){
                    
                    distance_matrix <- matrix(nrow = length(entry2_locations),
                                              ncol = length(entry1_locations))
                    colnames(distance_matrix) <- entry1_locations
                    rownames(distance_matrix) <- entry2_locations
                    for(j in 1:nrow(distance_matrix)){
                        for (k in 1:ncol(distance_matrix)){
                            value <-
                                sqrt((KEGG_mappings$Xcoord[KEGG_mappings$entryID ==
                                                               colnames(distance_matrix)[k]][1]
                                      - KEGG_mappings$Xcoord[KEGG_mappings$entryID ==
                                                                 rownames(distance_matrix)[j]][1])^2
                                     + (KEGG_mappings$Ycoord[KEGG_mappings$entryID ==
                                                                 colnames(distance_matrix)[k]][1]
                                        - KEGG_mappings$Ycoord[KEGG_mappings$entryID ==
                                                                   rownames(distance_matrix)[j]][1])^2)
                            # print(value)
                            distance_matrix[j,k] <- value
                        }
                    }
                    location <- which(distance_matrix == min(distance_matrix), arr.ind = TRUE)
                    entry_sources$entry1[i] <- colnames(distance_matrix)[location[1,2]]
                    entry_sources$entry2[i] <- rownames(distance_matrix)[location[1,1]]
                }
                if(length(entry1_locations) == 1 & length(entry2_locations) == 1){
                    entry_sources$entry1[i] <- entry1_locations
                    entry_sources$entry2[i] <- entry2_locations
                }
            }
        }
        entry_targets <- entry_edges[entry_edges$entry1accession == entry_accession &
                                         entry_edges$entry2accession %in% KEGG_mappings$entryACCESSION,]
        entry_targets <- entry_targets[!duplicated(entry_targets[,6:16]),]
        if(nrow(entry_targets) > 0){
            for(i in 1:nrow(entry_targets)){
                entry1_locations <- KEGG_mappings$entryID[KEGG_mappings$entrySYMBOL == entry_targets$entry1symbol[i]]
                entry2_locations <- KEGG_mappings$entryID[KEGG_mappings$entrySYMBOL == entry_targets$entry2symbol[i]]
                if(length(entry1_locations) > 1 | length(entry2_locations > 1)){
                    
                    distance_matrix <- matrix(nrow = length(entry2_locations),
                                              ncol = length(entry1_locations))
                    colnames(distance_matrix) <- entry1_locations
                    rownames(distance_matrix) <- entry2_locations
                    for(j in 1:nrow(distance_matrix)){
                        for (k in 1:ncol(distance_matrix)){
                            value <-
                                sqrt((KEGG_mappings$Xcoord[KEGG_mappings$entryID ==
                                                               colnames(distance_matrix)[k]][1]
                                      - KEGG_mappings$Xcoord[KEGG_mappings$entryID ==
                                                                 rownames(distance_matrix)[j]][1])^2
                                     + (KEGG_mappings$Ycoord[KEGG_mappings$entryID ==
                                                                 colnames(distance_matrix)[k]][1]
                                        - KEGG_mappings$Ycoord[KEGG_mappings$entryID ==
                                                                   rownames(distance_matrix)[j]][1])^2)
                            # print(value)
                            distance_matrix[j,k] <- value
                        }
                    }
                    location <- which(distance_matrix == min(distance_matrix), arr.ind = TRUE)
                    entry_targets$entry1[i] <- colnames(distance_matrix)[location[1,2]]
                    entry_targets$entry2[i] <- rownames(distance_matrix)[location[1,1]]
                }
                if(length(entry1_locations) == 1 & length(entry2_locations) == 1){
                    entry_targets$entry1[i] <- entry1_locations
                    entry_targets$entry2[i] <- entry2_locations
                }
            }
        }
        new_edges <- rbind(entry_sources, entry_targets)
        if(nrow(new_edges) > 0) {
            new_edges$primary_pathwayID <- strsplit(pathway_KGML@pathwayInfo@name, ":")[[1]][2]
            new_edges$primary_pathway <- pathway_KGML@pathwayInfo@title
            edges <- rbind(edges, new_edges)
        }
        print(p)
    }
    
    edges$edge_entry_ID <- paste0(edges$entry1, ":", edges$entry2)
    edge_ID_sets <- edges$edge_entry_ID[!duplicated(edges$edge_entry_ID)]
    edge_ID_mapper <- data.frame("edges" = edge_ID_sets, 
                                 edgeID = 1:length(edge_ID_sets),
                                 stringsAsFactors = FALSE)
    for(i in 1:nrow(edges)){
        edges$edgeID[i] <- edge_ID_mapper$edgeID[match(edges$edge_entry_ID[i], 
                                                       edge_ID_mapper$edges)]
    }
    edges <- edges[,names(edges) != "edge_entry_ID"]
    return(edges)
}



# KGML <- get_KGML("hsa04150")
# KEGG_mappings <- expand_KEGG_mappings(KGML)
# edges <- expand_KEGG_edges(KGML, KEGG_mappings)
# 

# 
# keggerize_edges <- function(entry_accession, KGML, KEGG_mappings, edges){
#     if(!"primary_pathway" %in% names(edges)){
#         edges$primary_pathwayID <- strsplit(KGML@pathwayInfo@name, ":")[[1]][2]
#         edges$primary_pathway <- KGML@pathwayInfo@title
#     }
#     entry_code <- paste0("hsa:",entry_accession)
#     entry_info <- keggGet(entry_code)
#     entry_pathways <- entry_info[[1]]["PATHWAY"]
#     entry_pathways <- names(entry_pathways$PATHWAY[1:length(unlist(entry_pathways))])
#     current_pathway <- strsplit(KGML@pathwayInfo@name, ":")[[1]][2]
#     entry_pathways <- entry_pathways[!entry_pathways %in% current_pathway]
#     for(i in 1:length(entry_pathways)){
#         pathway_KGML <- get_KGML(entry_pathways[i])
#         pathway_KEGG_mappings <- expand_KEGG_mappings(pathway_KGML)
#         pathway_edges <- expand_KEGG_edges(pathway_KGML, pathway_KEGG_mappings)
#         entry_edges <- pathway_edges[pathway_edges$entry1accession == entry_accession |
#                                          pathway_edges$entry2accession == entry_accession, ]
#         entry_sources <- entry_edges[entry_edges$entry1accession != entry_accession &
#                                          entry_edges$entry1accession %in% KEGG_mappings$entryACCESSION,]
#         # for(i in 1:nrow(entry_sources)){
#         #     entry1_locations <- KEGG_mappings$entryID[KEGG_mappings$entrySYMBOL == entry_sources$entry1symbol[i]]
#         #     entry2_locations <- KEGG_mappings$entryID[KEGG_mappings$entrySYMBOL == entry_sources$entry2symbol[i]]
#         #     distance_matrix <- matrix(nrow = length(entry2_locations), 
#         #                               ncol = length(entry1_locations))
#         #     colnames(distance_matrix) <- entry1_locations
#         #     rownames(distance_matrix) <- entry2_locations
#         #     for(j in 1:nrow(distance_matrix)){
#         #         for (k in 1:ncol(distance_matrix)){
#         #             value <- 
#         #                 sqrt((KEGG_mappings$Xcoord[KEGG_mappings$entryID ==
#         #                                               colnames(distance_matrix)[k]][1]
#         #                      - KEGG_mappings$Xcoord[KEGG_mappings$entryID ==
#         #                                                 rownames(distance_matrix)[j]][1])^2
#         #                      + (KEGG_mappings$Ycoord[KEGG_mappings$entryID ==
#         #                                                  colnames(distance_matrix)[k]][1]
#         #                         - KEGG_mappings$Ycoord[KEGG_mappings$entryID ==
#         #                                                    rownames(distance_matrix)[j]][1])^2)
#         #             print(value)
#         #             distance_matrix[j,k] <- value
#         #         }
#         #     }
#         #     
#         # 
#         # }
#         # for(i in 1:nrow(entry_sources)){
#         #     entry_sources$entry2[i] <- list(KEGG_mappings$entryID[KEGG_mappings$entrySYMBOL == entry_sources$entry2symbol[i]])
#         # }
#         # }
#         entry_targets <- entry_edges[entry_edges$entry1accession == entry_accession &
#                                          entry_edges$entry2accession %in% KEGG_mappings$entryACCESSION,]
#         new_edges <- rbind(entry_sources, entry_targets)
#         if(nrow(new_edges) > 0) {
#             new_edges$primary_pathwayID <- strsplit(pathway_KGML@pathwayInfo@name, ":")[[1]][2]
#             new_edges$primary_pathway <- pathway_KGML@pathwayInfo@title
#             
#             max_edge_ID <- max(edges$edgeID)
#             for(j in 1:nrow(new_edges)){
#                 new_edges$edgeID[j] <- max_edge_ID + j
#             }
#             edges <- rbind(edges, new_edges)
#         }
#         print(i)
#     }
#     edges$edge_entry_ID <- paste0(edges$entry1, ":", edges$entry2)
#     edge_ID_sets <- edges$edge_entry_ID[!duplicated(edges$edge_entry_ID)]
#     edge_ID_mapper <- data.frame("edges" = edge_ID_sets, 
#                                  edgeID = 1:length(edge_ID_sets),
#                                  stringsAsFactors = FALSE)
#     for(i in 1:nrow(edges)){
#         edges$edgeID[i] <- edge_ID_mapper$edgeID[match(edges$edge_entry_ID[i], 
#                                                        edge_ID_mapper$edges)]
#     }
#     edges <- edges[,names(edges) != "edge_entry_ID"]
#     return(edges)
# }
# 
# mtor_plus_mtor <- keggerize_edges(entry_accession = entry_accession, KGML = KGML,
#                                   KEGG_mappings = KEGG_mappings,
#                                   edges = edges)
# #dim(edges)
# #[1] 581  16
# # dim(mtor_plus_mtor)
# # [1] 757  18
# mtor_plus_mtor_plus_deptor <- keggerize_edges(entry_accession = "64798", KGML = KGML,
#                 KEGG_mappings = KEGG_mappings,
#                 edges = mtor_plus_mtor)
# 
# 
# 
# 
# 
# na_sources <- KEGG_gene_edges[is.na(KEGG_gene_edges$source),]
# na_targets<- KEGG_gene_edges[is.na(KEGG_gene_edges$target),]
# na_sources_and_targets <-  KEGG_gene_edges[is.na(KEGG_gene_edges$target)& is.na(KEGG_gene_edges$source),]
# 
# edges_complete_targets <- KEGG_gene_edges[!is.na(KEGG_gene_edges$target),] 
# complete_edges <- edges_complete_targets[!is.na(edges_complete_targets$source),]
# 
# # > dim(na_sources) + dim(na_targets) - dim(na_sources_and_targets)
# # [1] 2176   10
# # 
# # > dim(KEGG_gene_edges) - dim(complete_edges)
# # [1] 2176    0
# 
# 
# for(j in 1:nrow(distance_matrix)){
#     for (k in 1:ncol(distance_matrix)){
#         distance_matrix[j,k] <
#             sqrt((KEGG_mappings$Xcoord[KEGG_mappings$entryID ==
#                                            colnames(distance_matrix)[1]][1]
#                   - KEGG_mappings$Xcoord[KEGG_mappings$entryID ==
#                                              rownames(distance_matrix)[1]][1])^2
#                  + (KEGG_mappings$Ycoord[KEGG_mappings$entryID ==
#                                              colnames(distance_matrix)[1]][1]
#                     - KEGG_mappings$Ycoord[KEGG_mappings$entryID ==
#                                                rownames(distance_matrix)[1]][1])^2)
#     }
# }
# 
# KEGG_gene_edges <- complete_edges
# mtor_edges <- KEGG_gene_edges[KEGG_gene_edges$source == "MTOR" | KEGG_gene_edges$target == "MTOR",]
# 
# unique_mtor_edges <- mtor_edges[!duplicated(mtor_edges),]
# mtor_edges_all_pathways <- unique_mtor_edges
# 
# mtor_sources <- mtor_edges_all_pathways$source
# mtor_sources <- mtor_sources[!duplicated(mtor_sources)]
# # length(mtor_sources)
# # [1] 33
# mtor_targets <- mtor_edges_all_pathways$target
# mtor_targets <- mtor_targets[!duplicated(mtor_targets)]
# # length(mtor_targets)
# # [1] 26
# 
# mtor_KGML <- get_KGML("hsa04150")
# mtor_KEGG_mappings <- expand_KEGG_mappings(mtor_KGML)
# mtor_edges <- expand_KEGG_edges(mtor_KGML, mtor_KEGG_mappings)
# 
# sources_in_mtor_pathway <-  mtor_KEGG_mappings[mtor_KEGG_mappings$entrySYMBOL %in% mtor_sources,]
# # dim(sources_in_mtor_pathway)
# # [1] 28 16
# targets_in_mtor_pathway <-  mtor_KEGG_mappings[mtor_KEGG_mappings$entrySYMBOL %in% mtor_targets,]
# # dim(targets_in_mtor_pathway)
# # [1] 19 16
# internal_mtor_edges <- mtor_edges_all_pathways[mtor_edges_all_pathways$pathway_code == "path:hsa04150",]

#' See how many pathway gene knock-outs are available from data
#' @description Check quantity of data across cell lines available from LINCS
#'  corresponding to the pathway of interest 
#' @export 
#' @importFrom graphics barplot legend par
#' @importFrom utils data  
#' @param KEGG_mappings KEGG_mappings The data.frame object generated by the 
#' function expand_KEGG_mappings
#' @param pert_time Choose from (6,24,48,96,120,144,168)
#' @param generate_plot Logical indicator to generate histogram
#' @param get_KOs  Logical indicator to have data frame returned
#' @return A plot depicting percentage of pathway genes knocked-out by 
#' cell line and a data frame object listing the genes [by cell line]
#' @examples 
#' p53_KGML <- get_KGML("hsa04115")
#' p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML)
#' 
#' path_genes_by_cell_type(p53_KEGG_mappings)

path_genes_by_cell_type <- 
function(KEGG_mappings, pert_time = 96, get_KOs = FALSE, generate_plot = TRUE){
    keeps <- c("entryACCESSION", "entrySYMBOL")
    path_genes <- KEGG_mappings[KEGG_mappings$entryTYPE == "gene", keeps]
    names(path_genes)[2] <- "SYMBOL"
    path_genes <- data.frame(ENTREZID = unlist(path_genes$entryACCESSION), 
                            SYMBOL = unlist(path_genes$SYMBOL), 
                            stringsAsFactors = FALSE)
    path_genes <- path_genes[!duplicated(path_genes$ENTREZID), ]
    data("KO_data", envir = environment())
    cell_types <- data.frame(cell_type = unique(KO_data$cell_id), 
                             stringsAsFactors = FALSE)
    KO_data <- KO_data[KO_data$pert_time == pert_time, ]
    KO_data <- subset(KO_data, KO_data$pert_desc %in% path_genes$SYMBOL)
    by_cell_type <- data.frame(table(KO_data$cell_id), stringsAsFactors = FALSE)
    names(by_cell_type) <- c("cell_type", "num_pathway_KOs")
    by_cell_type$cell_type <- as.character(by_cell_type$cell_type)
    by_cell_type <- merge(cell_types, by_cell_type, 
                            incomparables = 0, all.x = TRUE)
    for (i in 1:nrow(by_cell_type)) {
        if (is.na(by_cell_type$num_pathway_KOs[i])) {
            by_cell_type$num_pathway_KOs[i] = 0
        }
        by_cell_type$knock_outs[i] <- list(KO_data$pert_desc[KO_data$cell_id ==
            by_cell_type$cell_type[i]])
        if (by_cell_type$num_pathway_KOs[i]/nrow(path_genes) > 0.6) {
            by_cell_type$color[i] <- "red"
        }
        if (by_cell_type$num_pathway_KOs[i]/nrow(path_genes) <= 0.6) {
            by_cell_type$color[i] <- "yellow"
        }
        if (by_cell_type$num_pathway_KOs[i]/nrow(path_genes) <= 0.4) {
            by_cell_type$color[i] <- "blue"
        }
    }
    by_cell_type <- by_cell_type[order(by_cell_type$num_pathway_KOs), ]
    if (generate_plot) {
        par(mar = c(5.1, 4.1, 4.1, 8.1), xpd = TRUE)
        barplot((by_cell_type$num_pathway_KOs/nrow(path_genes)) * 100, 
                names.arg = by_cell_type$cell_type, las = 2.5, 
                col = by_cell_type$color, 
                ylab = "Percentage of Pathway Genes Knocked Out", 
                cex.names = 0.8, main = "Pathway Coverage by Cell-Type")
        legend("topright", inset = c(-0.47, 0.2), 
                legend = c("60% +", "40% to 60%", 
                "Below 40%"), fill = c("red", "yellow", "blue"))
    }
    if (get_KOs) {
        return(by_cell_type)
    }
}

---
title: "KEGGlincs Workflows"
author: "Shana White"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
    %\VignetteIndexEntry{KEGGlincs Workflows}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

##Overview of KEGGlincs

```{r render_overview_png,eval=TRUE,echo=FALSE,out.width=800}
knitr::include_graphics("image_files/KEGGlincs_overview.jpeg")
```

The package KEGGlincs and the functions contained within it are designed such 
that users can explore KEGG pathways in a more meaningful and informative manner
both visually and analytically.  This method of pathway analysis is approached
via functions that handle the following (related) objectives:

- 'Expanding' node mapping for [assumed to be] paralogous node entries 
and grouped node entries
- Allowing data to be explicitly mapped to 'expanded' pathway edges 
(no summarization necessary)

The idea of 'expanded' nodes and edges should become very clear after reviewing 
the following example KEGGlincs workflows.  Please keep in mind, the individual 
functions detailed in the following workflows are incorporated into the 
`KEGG_lincs` 'master function'; these workflows are designed to provide users a 
with a better understanding of how this function works, how pathway topology is
represented in KGML files, and how this package could be used with 
non-LINCS edge data (see Workflow 2).

##Workflow 1: Visualize detailed 'expanded' KEGG pathways 
###No data added to edges 

This workflow is intended to give users insight into the 'expansion' of KEGG 
pathway mapping via manipulation of the source KGML file. The only input 
required is the KEGG pathway ID for your pathway of choice. The primary goal 
for this method of pathway re-generation is to give users insight into the 
complexity that underlies many KEGG pathways but is in a sense 'hidden', yet 
hard-coded, in the curated KGML files.  Users can also see the *exact* pathway
topology that is used for input in analyses such as SPIA (Signaling Pathway 
Impact Analysis).

####Initialize KEGGlincs package (development phase)
```{r initialize, message = FALSE, warning=FALSE}
library(KEGGlincs)
```

####Download and parse the most current KGML file for Fox0 signaling pathway
```{r get_KGML, collapse=TRUE}
FoxO_KGML <- get_KGML("hsa04068")

#Information from KGML can be accessed using the following syntax:
slot(FoxO_KGML, "pathwayInfo")
```
####The code chunks below are useful for viewing the original pathway image.

```{r access_KGML, collapse=TRUE}
#Get address for pathway with active links:
slot(slot(FoxO_KGML, "pathwayInfo"), "image")
```

```{r get_png, eval = FALSE}
#Download a static pathway image (png file) to working directory:
image_link <- slot(slot(FoxO_KGML, "pathwayInfo"), "image")
download.file(image_link, basename(image_link), mode = "wb")
```

#####Rendering of the png file for the p53 signaling pathway from KEGG:
```{r render_png,eval=TRUE,echo=FALSE,out.width=800}
knitr::include_graphics("image_files/hsa04068.png")
```

#####The following commands produce 'expanded' node and edge sets
Note that KEGG IDs are converted to gene/compound symbols; this conversion 
accounts for the majority of computing time behind the `expand_KEGG_mappings` 
function. For quicker map generation, users may chose to change the argument 
`convert_KEGG_IDs` to `FALSE`; this will result in edges being identified by 
pairs of accession numbers instead of symbols in the final pathway map (example
at end of this workflow using `KEGG_lincs` master function).

```{r speed_up_for_ex, echo=FALSE}
FoxO_KEGG_mappings <- expand_KEGG_mappings(FoxO_KGML, convert_KEGG_IDs = FALSE)
```

```{r expand_mapping_for_show, eval=FALSE}
FoxO_KEGG_mappings <- expand_KEGG_mappings(FoxO_KGML)
```

```{r expand_edges}
FoxO_edges <- expand_KEGG_edges(FoxO_KGML, FoxO_KEGG_mappings)
```

#####Compare counts for 'expanded' vs. 'unexpanded' nodes and edges:
```{r compare_lengths, collapse=TRUE}
length(graph::nodes(FoxO_KGML)) # 'Un-expanded' nodes
nrow(FoxO_KEGG_mappings)        # 'Expanded' nodes

length(graph::edges(FoxO_KGML)) # 'Un-expanded' edges
nrow(FoxO_edges)                # 'Expanded' edges
```

#####Add graphing information to nodes and edges and get graph object:
Note: While the `node_mapping_info` function is rather trivial, the
`edge_mapping_info` functions differently when data is added.
```{r mapping_info, collapse=TRUE}
#Modify existing data sets; specify as nodes and edges
FoxO_node_mapping_info <- node_mapping_info(FoxO_KEGG_mappings)
FoxO_edge_mapping_info <- edge_mapping_info(FoxO_edges)

#Create an igraph object
GO <- get_graph_object(FoxO_node_mapping_info, FoxO_edge_mapping_info)
class(GO)
```

#####Finally, transform graph object and send to Cytoscape with one command:
```{r cyto_vis, collapse=TRUE, eval=FALSE}
cyto_vis(GO, "FoxO Pathway with Expanded Edges[no data added]")
```

#####Graph rendered in Cytoscape:
```{r render_graph,eval=TRUE,echo=FALSE,out.width=800}
knitr::include_graphics("image_files/foxo_ID_conversion.jpeg")
```
Edge Color Key:

<span style="color:red">Red: Activation or Expression </span> *

<span style="color:orange">Orange: Activating PTM </span> **

<span style="color:green">
Green: PTM (no activation/inhibition activity defined) </span> 

<span style="color:blue">Blue: Inhibition </span>

<span style="color:purple">Purple: Inhibiting PTM </span>

Black(solid): Binding/Association

Black(dashed): Indirect effect (no activation/inhibition activity defined)

*Any dashed colored line indicates that the effect is indirect

**PTM = post-translational modification or, as KEGG defines them, 
'molecular events'.

+ The specific types of PTMS (indicated by edge label) include:
    - +p: phosphorylation
    - -p: dephosphorylation
    - +g: glycosylation
    - +u: ubiquitination
    - +m: methylation

Notice that the original KEGG pathway image includes visual elements such as 
cellular-component-demarcations and certain edges (especially those 'connecting'
genes to other pathways) that are not rendered in Cytoscape.  These are features
that are either not explicitly part of the pathway topology (i.e. not nodes or 
edges connecting nodes) or have not been hard-coded in the KGML file.  The node
labels may also differ between maps (KEGGlincs labels nodes as the first 'alias'
in the respective KGML slot as there is no corresponding 'label' slot).

#####Alternative: KEGG_lincs master function
The steps above may be avoided if the user does not wish to generate 
intermediary files/objects by making use of the function  `KEGG_lincs` as 
follows:

```{r eval = FALSE}
KEGG_lincs("hsa04068")
```

If users would like the Cytoscape-rendered map along with the detailed list of 
expanded edges (as an R object), `KEGG_lincs` can be invoked as follows:
```{r eval = FALSE}
FoxO_edges <- KEGG_lincs("hsa04068")
```

To speed up the mapping process (at the expense of having edges labelled with 
pairs of gene accession numbers as opposed to symbols) users may change the 
default `convert_KEGG_IDs` argumet to `FALSE`
```{r eval = FALSE, echo = TRUE}
KEGG_lincs("hsa04068", convert_KEGG_IDs = FALSE)
```

*Note: As with `cyto_vis`, please use the function `KEGG_lincs_auto` (after 
sourcing `cyto_vis_auto`) available from :
https://github.com/uc-bd2k/KEGGlincs/blob/master/R/KEGG_lincs_auto.R
#####Graph rendered in Cytoscape without edge accession numbers converted:
```{r render_graph_fast,eval=TRUE,echo=FALSE,out.width=800}
knitr::include_graphics("image_files/foxo_no_IDconversion.jpeg")
```


##Workflow 2: Overlay data to edges of KEGG pathway 
###Specific use case: LINCS L1000 Knock-out data

While the functions described in Workflow 1 are certainly useful for any users 
wishing to gain deeper insight into KEGG pathway topology and 'hard-coded' KGML
information, the drving force motivating the KEGGlincs package development is 
the association of experimental data with pathway edges. 

The companion data package *KOdata* provides data for the edges rendered by the 
master function `KEGG_lincs`.  This data package includes two unique data sets; 
one contains lists of significantly up- and down-regulated genes corresponding
to knocked-out genes (within individual experiments, genes are 'turned off' via 
shRNA) across a variety of cell-lines measured at specific times and 
the other is a binary record of baseline gene expression (gene is either 
expressed or not expressed) for most cell-lines from the knock-out data set.   

```{r show_KO_data, eval=TRUE,echo=FALSE,out.width=800}
knitr::include_graphics("image_files/random_KO_info.jpeg")
```

While this package was developed primarily as a way to compare pathway topology
between cell-lines or within cell-lines [across time] using LINCS L1000 data, 
this workflow will demonstrate the package's flexibility for users incorporating
edge data from any source.

#####Example: Comparing p53 Signalling Pathway between Cell-Lines
As a hypothetical scenario, our goal will be to compare pathway topology between
cell-lines for an important cancer-related pathway: the p53 Signaling Pathway.

The 'default' pathway (with no data added to edges) can be generated either by
following Workflow 1 or by using the `KEGG_lincs` master function as follows:
```{r default_p53, eval = FALSE, echo = TRUE}
KEGG_lincs("hsa04115")
```
```{r show_p53_default, eval=TRUE,echo=FALSE,out.width=800}
knitr::include_graphics("image_files/p53_default.jpeg")
```

From here, the first few lines of code are similar to those of Workflow 1:

```{r begin_workflow1}
p53_KGML <- get_KGML("hsa04115")
p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML)
p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)
```

An important aspect of the L1000 knock-out and expression data is that it is
incomplete; experimental data is not uniformly available for each cell-line.  
Therefor (for this specific example with this specific data set) it is 
instructive to find out which cell-lines make sense to compare; intuitively, 
cell-lines with a similar percentage of pathway genes knocked out would be
well suited for comparison.  The following command accomplished this task in
the form of an easily interpretable graphical output:
```{r show_pathway_genes, eval=FALSE}
path_genes_by_cell_type(p53_KEGG_mappings)
```

```{r render_barplot, eval=TRUE,echo=FALSE,out.width=500}
knitr::include_graphics("image_files/p53_coverage_graph.png")
```

Another function (`refine_mappings`) is automatically envoked when the 
`KEGG_lincs` master function is called; this function 'prunes' edges from the
pathway that would not exist in the cell-line based on baseline expression data.
This is beyond the scope of this workflow and will be detailed elsewhere.

If users would like to access lists of specific gene knock-outs within the 
chosen pathway for each cell-line, the command can be invoked as follows:

```{r show_summary_for_ex, eval = FALSE}
p53_L1000_summary <- path_genes_by_cell_type(p53_KEGG_mappings, get_KOs = TRUE)
```

Resulting data frame:
```{r avoid_poor_map_render, echo=FALSE}
p53_L1000_summary <- path_genes_by_cell_type(p53_KEGG_mappings, get_KOs = TRUE,
                                                generate_plot = FALSE)

knitr::kable(tail(p53_L1000_summary))
```

The bar plot suggests that the group of cell lines colored in red have
similar amounts of pathway information; for this example we will compare the
PC3 (prostate cancer) and HA1E (immortalized normal kidney epithelial) 
cell-lines.

The following commands use the data objects generated above to generate 
cell-line specific edge attributes corresponding to specific pathway edges and 
the information from the L1000 knock-out data set:

```{r overlap_info, eval=TRUE, collapse=TRUE}
p53_PC3_data <- overlap_info(p53_KGML, p53_KEGG_mappings, "PC3")

p53_HA1E_data <- overlap_info(p53_KGML, p53_KEGG_mappings, "HA1E")
```

Example of edge data generated for the PC3 cell line
(data columns generated after applying Fisher's exact test not shown):
```{r show_overlap_data, echo = FALSE}
knitr::kable(head(p53_PC3_data[1:6]))
```

The argument `keep_counts_only` in `overlap_info` is by default set to `FALSE`.
Users may be interested in follow-up analysis of the genes that are found to be
expressed in a concordant/discordant fashion between pairs of knock outs.  This
information is easily accessible by changing the default as follows:

```{r overlap_info_plus_genes, eval=TRUE, collapse=TRUE}
p53_PC3_data_with_gene_lists <- overlap_info(p53_KGML, p53_KEGG_mappings, 
                                            "PC3", keep_counts_only = FALSE)
```

Example of edge data generated for the PC3 cell line that includes lists of 
concordant/discordant genes for knock out pairs (count data not shown):
```{r show_overlap_data_plus_genes_PC3, echo = FALSE}
knitr::kable(head(p53_PC3_data_with_gene_lists[c(1:2, 7:10)]))
```

By default, the function `overlap_info` generates edges that are 'mapped', i.e.
the edge between any two nodes is hard-coded in the KGML file even though data
could be generated for all *possible* (think *de novo*) edges.  A workflow that
describes how this can be achieved by simply changing a few default arguments 
will be added shortly.

Notice the format of the data; in particular that the first two columns contain
gene symbols and act as a primary key (unique identifier) for an edge and the 
rest of the columns are edge attributes.  The following function `add_edge_data`
can be used with any dataset in this format and will append selected columns to
the edge dataset.  Note that the data supplied does not need to be pre-arranged
in correct source -> target order as specified by the pathway topology; the 
function automatically re-orients pairs correctly. 

```{r add_edges}
p53_PC3_edges <- add_edge_data(p53_edges, p53_KEGG_mappings,
                                    p53_PC3_data, only_mapped = TRUE,
                                    data_column_no = c(3,10,12))

p53_HA1E_edges <- add_edge_data(p53_edges, p53_KEGG_mappings,
                                p53_HA1E_data, only_mapped = TRUE,
                                data_column_no =  c(3,10,12))
```

The following series of commands follow from workflow 1 (with minor adjustments
to arguments, notably ensuring that `data_added = TRUE` is specified).  The
edges in the resulting pathway maps are conditionally formatted to represent 
both the significance and magnitude of the relationship between corresponding 
nodes based on their concordance/discordance of up/down-regulated genes as 
measured by Fisher's Exact Test. 

+  Note that [in Cytoscape] graphs rendered in 
the same session inherit certain style elements from existing graphs that are
not updated when the new graph gets pushed (such as range for conditional 
formatting); therefor it is [in this author's opinion] best-practice to  start 
with a fresh session when mapping requires conditional formatting. 

```{r get_mapping_info, eval = FALSE}
p53_node_map <- node_mapping_info(p53_KEGG_mappings)

p53_edge_map_PC3 <- edge_mapping_info(p53_PC3_edges, data_added = TRUE,
                                        significance_markup = TRUE)
p53_edge_map_HA1E <- edge_mapping_info(p53_HA1E_edges, data_added = TRUE,
                                        significance_markup = TRUE)


PC3_GO <- get_graph_object(p53_node_map, p53_edge_map_PC3)
HA1E_GO <- get_graph_object(p53_node_map, p53_edge_map_HA1E)

cyto_vis(PC3_GO, "Pathway = p53, Cell line = PC3")
#Option: Save PC3 as .cys file and start a fresh session in Cytoscape 
cyto_vis(HA1E_GO, "Pathway = p53, Cell line = HA1E")
```

Edge colors represent the following possible combinations of direction
of Fisher's Exact Test summary scores (a modified Odd's Ratio score; either 
positive(+) or negative (-)) and their corresponding [adjusted] p-values:

<span style="color:red">Red: OR(+), pval(sig) </span> 

<span style="color:orange">Orange: OR(+), pval(non-sig) </span> 

<span style="color:purple">Purple: OR(-), pval(non-sig) </span>

<span style="color:blue">Blue: OR(-), pval(sig) </span>

#####Graphs rendered in Cytoscape:
```{r render_graphs,eval=TRUE,echo=FALSE,out.width=800}
knitr::include_graphics("image_files/p53_PC3_vignette.jpeg")
knitr::include_graphics("image_files/p53_HA1E_vignette.jpeg")
```

Note that as with Workflow 1, the `KEGG_lincs` master function can
automatically generate pathway maps identical to the final maps resulting
from Workflow 2 as follows:

```{r auto_map, eval = FALSE}
KEGG_lincs("hsa04115", "PC3", refine_by_cell_line = FALSE)
KEGG_lincs("hsa04115", "HA1E", refine_by_cell_line = FALSE)
```

The only differences are that the `KEGG_lincs` function generates titles with a
slightly modified format and automatically 'refines' pathway edges for
cell-lines with baseline expression data.

#####Graphs rendered in Cytoscape:
```{r render_graphs_kegglincs,eval=TRUE,echo=FALSE,out.width=800}
knitr::include_graphics("image_files/p53_PC3.jpeg")
knitr::include_graphics("image_files/p53_HA1E.jpeg")

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/refine_mappings.R
\name{refine_mappings}
\alias{refine_mappings}
\title{Refine pathway by cell type}
\usage{
refine_mappings(KEGG_mappings, cell_line)
}
\arguments{
\item{KEGG_mappings}{The data.frame object generated by the function 
expand_KEGG_mappings}

\item{cell_line}{Choose from the set of cell lines with baseline data; 
cell-lines may or may not have corresponding KO data}
}
\value{
A dataframe object with reduced set of pathway mappings to be
 passed on to other functions
}
\description{
Reduce the KEGG pathway by only including genes that are 
expressed within a given cell type
}
\examples{
p53_KGML <- get_KGML("hsa04115")
p53_KEGG_mappings <-  expand_KEGG_mappings(p53_KGML)
MCF7_p53_mappings <- refine_mappings(p53_KEGG_mappings, "MCF7")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/overlap_info.R
\name{overlap_info}
\alias{overlap_info}
\title{Get overlap information for pairs of gene knock-outs from LINCS data}
\usage{
overlap_info(KGML_file, KEGG_mappings, cell_type, data_type = "100_full",
  pert_time = 96, only_mapped = TRUE, affy_based = FALSE,
  keep_counts_only = TRUE, add_fisher_information = TRUE,
  p.adjust.method = "BH")
}
\arguments{
\item{KGML_file}{An object of formal class KEGGPathway}

\item{KEGG_mappings}{The data.frame object generated by the function 
expand_KEGG_mappings}

\item{cell_type}{Choose from the set of cell lines: 
(A375,A549,ASC,HA1E,HCC515,HEK293T,HEKTE,HEPG2,HT29,MCF7,NCIH716,NPC,PC3,
SHSY5Y,SKL,SW480,VCAP)}

\item{data_type}{Choose from data types: (100_full, 100_bing, 50_lm)}

\item{pert_time}{Choose from (6,24,48,96,120,144,168)}

\item{only_mapped}{A logical indicator; if set to FALSE will return 'de-novo'
edges that 'exist' in data but are not documented in KEGG}

\item{affy_based}{A logical indicator; if set to TRUE will return 
lists/counts based on probeID instead of gene symbol.}

\item{keep_counts_only}{A logical indicator; if set to FALSE will return 
data frame with lists [of gene symbols or probe ids] as well as counts}

\item{add_fisher_information}{A logical indicator; by default the 
relationships are analyzed for strength of correlation via 
Fisher's Exact Test}

\item{p.adjust.method}{For available methods, type 'p.adjust.methods' into 
command promt and press enter.}
}
\value{
A data frame where each row corresponds to information for pairs of 
experimental gene knock-outs from LINCS data (found in selected pathway).
}
\description{
Get overlap information for pairs of gene knock-outs from LINCS data
}
\examples{
p53_KGML <- get_KGML("hsa04115")
p53_KEGG_mappings <-  expand_KEGG_mappings(p53_KGML)
p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)

summary <- path_genes_by_cell_type(p53_KEGG_mappings)
p53_HA1E_data <- overlap_info(p53_KGML, p53_KEGG_mappings, 
                               "HA1E", data_type = "100_bing", 
                               only_mapped = FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/path_genes_by_cell_type.R
\name{path_genes_by_cell_type}
\alias{path_genes_by_cell_type}
\title{See how many pathway gene knock-outs are available from data}
\usage{
path_genes_by_cell_type(KEGG_mappings, pert_time = 96, get_KOs = FALSE,
  generate_plot = TRUE)
}
\arguments{
\item{KEGG_mappings}{KEGG_mappings The data.frame object generated by the 
function expand_KEGG_mappings}

\item{pert_time}{Choose from (6,24,48,96,120,144,168)}

\item{get_KOs}{Logical indicator to have data frame returned}

\item{generate_plot}{Logical indicator to generate histogram}
}
\value{
A plot depicting percentage of pathway genes knocked-out by 
cell line and a data frame object listing the genes [by cell line]
}
\description{
Check quantity of data across cell lines available from LINCS
 corresponding to the pathway of interest
}
\examples{
p53_KGML <- get_KGML("hsa04115")
p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML)

path_genes_by_cell_type(p53_KEGG_mappings)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_fisher_info.R
\name{get_fisher_info}
\alias{get_fisher_info}
\title{Perform Fisher's Exact test for edges in pathway}
\usage{
get_fisher_info(edges, method)
}
\arguments{
\item{edges}{The set of eges to be analyzed; Although the intended use is for
LINCS data overlaps, the function should work with any typical data object as
long as it has columns labeled ("UP", "DOWN", "UK1_DK2", "DK1_UK2") that 
contain integer values.}

\item{method}{The method to correct/adjust p-values for multiple testing. 
For available methods, type 'p.adjust.methods' into command promt and 
press enter.}
}
\value{
The input edge data.frame object with additional columns containing
the results of the applied statistical test
}
\description{
Obtain a measure for strength and significance for the 
relationship (i.e. an edge) based on the concordance/discordance of 
UP-and-DOWN regulated genes shared by two different experimental 
gene-knockouts
Intended for use within \code{\link{overlap_info}}
}
\examples{
ex.data <- data.frame("UP" = c(70,6), "DOWN" = c(8,20),
                    "UK1_DK2" = c(4,47), "DK1_UK2" = c(3, 28))

overlaps <- get_fisher_info(ex.data, method = "BH")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/edge_mapping_info.R
\name{edge_mapping_info}
\alias{edge_mapping_info}
\title{Prepare edges for mapping}
\usage{
edge_mapping_info(expanded_edges, data_added = FALSE,
  significance_markup = FALSE, tidy_edge = TRUE)
}
\arguments{
\item{expanded_edges}{The data frame object generated via the function 
expand_KEGG_edges() OR has been modified by the function add_edge_data()}

\item{data_added}{A logical indicator; must be set to TRUE if user data has
been added (i.e. edges modified by function add_edge_data())}

\item{significance_markup}{A logical indicator; if set to TRUE will color 
edges based on direction and significance of correlation (as determined by 
user-data-analysis)}

\item{tidy_edge}{A logical indicator; must be set to FALSE for expanded edges}
}
\value{
A data.frame object for edges that will be passed on to the function 
get_graph_object
}
\description{
Modify the mapping information for desired look when graphed in
 Cytoscape
}
\examples{
p53_KGML <- get_KGML("hsa04115")
p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML)

#Default; no data added to edges:

p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)
p53_edge_mapping_info <- edge_mapping_info(p53_edges) 

#If data is added to edges as additional attribute[s]:

p53_HA1E_data <- overlap_info(p53_KGML, p53_KEGG_mappings, 
                               "HA1E", data_type = "100_bing")

p53_edges_HA1E_data_MAPPED <- add_edge_data(p53_edges, p53_KEGG_mappings, 
                                            p53_HA1E_data, 
                                            data_column_no = c(3, 10,12),
                                            only_mapped = TRUE)
                                               
p53_edge_mapping_HA1E <- edge_mapping_info(p53_edges_HA1E_data_MAPPED, 
                                                      data_added = TRUE)
                                                      
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/expand_KEGG_mappings.R
\name{expand_KEGG_mappings}
\alias{expand_KEGG_mappings}
\title{Get detailed KEGG mapping information for each map entity}
\usage{
expand_KEGG_mappings(KGML_file, convert_KEGG_IDs = TRUE)
}
\arguments{
\item{KGML_file}{An object of formal class KEGGPathway}

\item{convert_KEGG_IDs}{A logical indicator; if set to FALSE will run faster
however genes and compounds will remain labeled via KEGG codes (compounds) 
or accession numbers (genes).  This option must be taken into account if 
data is being added.  For example, the genes in 'KO_data' are identified by
symbols, thus it is neccessary to retain the default option to convert IDs
to symbols when planning to add edge data of this type.}
}
\value{
A dataframe object with unique entry information for all [node]
 objects documented in the KEGG pathway. 
        Note that if mutiple objects (i.e. genes or compounds) have the same 
        entryID, this indicates that they share the same node [location] 
        in the pathway.
}
\description{
Extract mapping information from KGML object and normalize 
mappings based on multi-valued name attribute
}
\examples{
p53_KGML <- get_KGML("hsa04115")
p53_KEGG_mappings <-  expand_KEGG_mappings(p53_KGML, FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_graph_object.R
\name{get_graph_object}
\alias{get_graph_object}
\title{Generate graph object from nodes and edges}
\usage{
get_graph_object(node_mapping_info, expanded_edges,
  layered_nodes = FALSE)
}
\arguments{
\item{node_mapping_info}{The data.frame object generated by the function 
node_mapping_info()}

\item{expanded_edges}{The data.frame object generated by the function 
edge_mapping_info()}

\item{layered_nodes}{A logical indicator; if set to TRUE will create a 
graph with 'stacked' nodes that the user can manipulate when multiple nodes 
are mapped to one location}
}
\value{
A list object with the node and edge information from the graph 
required for mapping.
}
\description{
Obtain a graph object in the form of an igraph with 
KEGG-specific graphical information
}
\examples{

p53_KGML <- get_KGML("hsa04115")
p53_KEGG_mappings <-  expand_KEGG_mappings(p53_KGML)

p53_node_mapping_info <- node_mapping_info(p53_KEGG_mappings)
p53_edge_mapping_info <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)

#Default graph object will have 'expanded edges':
expanded_edges_graph_object <- get_graph_object(p53_node_mapping_info, 
                                                p53_edge_mapping_info)

#Graph with layered nodes:
layered_nodes_graph_object <- get_graph_object(p53_node_mapping_info,
                                               p53_edge_mapping_info, 
                                               layered_nodes = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generate_mappings.R
\name{generate_mappings}
\alias{generate_mappings}
\title{The 'boilerplate' for this package's desired graph style}
\usage{
generate_mappings(style_name, map_edge_width, edge_width_attribute,
  min_score, max_score)
}
\arguments{
\item{style_name}{An argument to name style; when used inside 
of \code{\link{cyto_vis}} no name is needed}

\item{map_edge_width}{A logical indicator; if FALSE no continuous mapping 
of edge width will be applied}

\item{edge_width_attribute}{The attribute that will be used for edge width; 
if data is not added or the attribute is not part of the graphing 
information, the edge width will default to 1.}

\item{min_score}{The minimum attribute value for the column used to map 
edge width}

\item{max_score}{The maximum attribute value for the column used to map 
edge width}
}
\value{
A list that can be converted to a JSON file to apply desired 
style/layout in Cytoscape
}
\description{
Generates an object that can be converted to a JSON file 
and subsequently applied to the graph for the markup specified by this
 package and the layout mirroring KEGG.
Intended for use within \code{\link{cyto_vis}}
}
\examples{
style.name = "myKEGGstyle"
mappings <- generate_mappings(style.name, FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/node_mapping_info.R
\name{node_mapping_info}
\alias{node_mapping_info}
\title{Prepare nodes for mapping}
\usage{
node_mapping_info(KEGG_mappings)
}
\arguments{
\item{KEGG_mappings}{The data.frame object generated by the function 
expand_KEGG_mappings()}
}
\value{
A data.frame object for nodes that will be passed on to the function 
get_graph_object
}
\description{
Modify the mapping information for desired look when graphed 
in Cytoscape
}
\examples{
p53_KGML <- get_KGML("hsa04115")
p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML, FALSE)

p53_node_mapping_info <- node_mapping_info(p53_KEGG_mappings)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/keggerize_edges.R
\name{keggerize_edges}
\alias{keggerize_edges}
\title{Add in edges to map documented in other pathways}
\usage{
keggerize_edges(entry_accession, KGML, KEGG_mappings, edges)
}
\arguments{
\item{entry_accession}{The Accession # of the pathway entity to 'keggerize'}

\item{KGML}{The KGML file of the current pathway}

\item{KEGG_mappings}{KEGG mappings for the current pathway}

\item{edges}{The expanded edges for the current pathway}
}
\value{
A modified expanded edges data frame with additional rows for new 
entries
}
\description{
For a specific pathway entity(gene), search KEGG databases
to see if it has any other documented relationships in KEGG.
expand_KEGG_edges
}
\examples{
\dontrun{
KGML <- get_KGML("hsa04150")
KEGG_mappings <- expand_KEGG_mappings(KGML)
edges <- expand_KEGG_edges(KGML, KEGG_mappings)
entry_accession <- "2475"
mtor_plus_mtor <- keggerize_edges(entry_accession = entry_accession, 
                                  KGML = KGML,KEGG_mappings = KEGG_mappings,
                                  edges = edges) }

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cyto_vis.R
\name{cyto_vis}
\alias{cyto_vis}
\title{Send graph to Cytoscape via CyREST}
\usage{
cyto_vis(graph_object, title = "Cytoscape Graph Window",
  edge_width_attribute = "summary_score", port.number = 1234)
}
\arguments{
\item{graph_object}{An igraph object such as the one generated by the 
function \code{\link{get_graph_object}}}

\item{title}{An optional title for the graph when it is in Cytoscape}

\item{edge_width_attribute}{The attribute that will be used for edge width; 
if data is not added or the attribute is not part of the graphing 
information, the edge width will default to 1.}

\item{port.number}{The port address for Cytoscape}
}
\value{
A dynamic map in Cytoscape automatically formatted for convenient 
viewing.
}
\description{
View the KEGG pathway in Cytoscape. With either the 
'expanded edges' or 'stacked nodes' layout, users can visualize and interact 
with the graphs [strictly] as they are documented in the most recent KGML
available from KEGG.  
This function is a modified version of the function send2cy(),
 which is part of the cyREST utility functions.
}
\examples{
p53_KGML <- get_KGML("hsa04115")
p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML, FALSE)
nodes <- node_mapping_info(p53_KEGG_mappings)

p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)
edges <- edge_mapping_info(p53_edges) 

p53_graph_object <- get_graph_object(nodes, edges)
                                      
\dontrun{
cyto_vis(p53_graph_object, "Default p53 Graph [no data added]")

#Workflow to visualize graph with data-dependent attributes:

p53_KGML <- get_KGML("hsa04115")
p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML)
nodes <- node_mapping_info(p53_KEGG_mappings)

p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)

p53_HA1E_data <- overlap_info(p53_KGML, p53_KEGG_mappings, "HA1E", 
                               data_type = "100_bing")
p53_edges_plus_data <- add_edge_data(p53_edges, p53_KEGG_mappings, 
                                      p53_HA1E_data, c(3, 10,12),
                                      only_mapped = TRUE)

edges <- edge_mapping_info(p53_edges_plus_data, data_added = TRUE)
                                            
p53_plus_data_graph_object <- get_graph_object(nodes, edges)
                                                
cyto_vis(p53_plus_data_graph_object, "p53 Graph: Mapped Edges + HA1E Data",
         edge_width_attribute = "UP")
         }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/from_cyREST.R
\name{toCytoscape}
\alias{toCytoscape}
\alias{mapAttributes}
\title{cyREST utility functions}
\usage{
toCytoscape(igraphobj)

mapAttributes(attr.names, all.attr, i)
}
\arguments{
\item{igraphobj}{A graph object compatible for use with the package igraph}

\item{attr.names}{Attribute names of an igraph object}

\item{all.attr}{The attribute value if an igraph object}

\item{i}{The index for a given igraph object}
}
\value{
A JSON object to be sent to Cytoscape
}
\description{
A subset of the R utility functions available from/defined
 by cyREST.  The function mapAttributes is called from within toCytoscape 
 which, in turn, is called from within cyto_vis.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/KEGGlincs.R
\docType{package}
\name{KEGGlincs}
\alias{KEGGlincs}
\alias{KEGGlincs-package}
\title{KEGGlincs: an R package designed to explore the edges in KEGG pathways}
\description{
KEGGlincs: an R package designed to explore the edges in KEGG pathways
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tidy_edge.R
\name{tidy_edge}
\alias{tidy_edge}
\title{Tidy up pathway by combining edges inside of edge_mapping_info}
\usage{
tidy_edge(edges, edge_id, data_added = FALSE, by_significance = FALSE,
  by_number = TRUE)
}
\arguments{
\item{edges}{The edge dataframe}

\item{edge_id}{The numeric value for the edge_id}

\item{data_added}{A logical indicator; set to TRUE if data is added}

\item{by_significance}{A logical indicator; option if data is added}

\item{by_number}{A logical indicator; gives rough estimate of edge amount}
}
\value{
A data frame that has had the given edge condensed for viewing
}
\description{
Combine edges that share nodes and have other commonalities
}
\examples{
\dontrun{
if (tidy_edge == TRUE) {
   edge_IDs <- seq(min(expanded_edges$edgeID), max(expanded_edges$edgeID))
   for (i in edge_IDs){
     if(data_added == TRUE){
       expanded_edges <- tidy_edge(edges = expanded_edges,
                                   edge_id = edge_IDs[i], 
                                   data_added = TRUE,
                                   by_significance = TRUE)
     }
     if(data_added == FALSE){
       expanded_edges <- tidy_edge(edges = expanded_edges,
                                   edge_id = edge_IDs[i], 
                                   data_added = FALSE)
     }
   }

}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/KEGG_lincs.R
\name{KEGG_lincs}
\alias{KEGG_lincs}
\title{Combines all other package functions for one-step pathway visualization}
\usage{
KEGG_lincs(pathwayid, cell_line = NA, refine_by_cell_line = NA,
  add_L1000_edge_data = TRUE, significance_markup = TRUE,
  data_type = "100_full", pert_time = 96, only_mapped = TRUE,
  layered_nodes = FALSE, graph_title = "default", get_data = FALSE,
  convert_KEGG_IDs = TRUE, tidy_edge = FALSE)
}
\arguments{
\item{pathwayid}{A KEGG pathway ID of the form "hsa12345" 
(only human pathways currently)}

\item{cell_line}{If left as NA will generate a pathway map without 
data-dependent attributes (such as edge width).  To use in combination 
with LINCS data, choose from the set of cell lines: 
(A375,A549,ASC,HA1E,HCC515,HEK293T,HEKTE,HEPG2,HT29,MCF7,NCIH716,NPC,PC3,
SHSY5Y,SKL,SW480,VCAP)}

\item{refine_by_cell_line}{A logical indicator}

\item{add_L1000_edge_data}{A logical indicator}

\item{significance_markup}{A logical indicator; if set to TRUE will color
edges based on direction and significance of correlation (as determined by 
user-data-analysis)}

\item{data_type}{Choose from data types: (100_full, 100_bing, 50_lm)}

\item{pert_time}{Choose from (6,24,48,96,120,144,168)}

\item{only_mapped}{A logical indicator; if set to FALSE will return 'de-novo'
edges that 'exist' in data but are not documented in KEGG}

\item{layered_nodes}{A logical indicator; if set to TRUE will create a graph 
with 'stacked' nodes that the user can manipulate when multiple nodes are 
mapped to one location}

\item{graph_title}{An optional user-specified graph title}

\item{get_data}{A logical indicator; if set to true, will return the 
'expanded' edge information for the specified pathway}

\item{convert_KEGG_IDs}{A logical indicator; if set to TRUE KEGG 
compounds will remain labeled via KEGG codes (do not need KEGGREST)}

\item{tidy_edge}{A logical indicator; must be set to FALSE for expanded edges}
}
\value{
A dynamic map in Cytoscape automatically formatted for convenient 
viewing and, if idicated by user, a data.frame object with detailed 
information for 'expanded' KEGG edges
}
\description{
Combines all other package functions for one-step pathway visualization
}
\examples{
\dontrun{ 

#Default KEGG pathway with colored edges representing type of relationship:
KEGG_lincs("hsa04115", convert_KEGG_IDs = FALSE)

#KEGG pathway with edge width and color based on observed experimental data:
KEGG_lincs("hsa04115", "HA1E")

#Have edge information data.frame to be output to the global environment:
p53_edge_info <- KEGG_lincs("hsa04115", graph_title = "p53"
                             convert_KEGG_IDs = FALSE, get_data = TRUE)
                             }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/expand_KEGG_edges.R
\name{expand_KEGG_edges}
\alias{expand_KEGG_edges}
\title{Get detailed KEGG mapping information for each relation [edge] documented 
in KEGG}
\usage{
expand_KEGG_edges(KGML_file, KEGG_mappings)
}
\arguments{
\item{KGML_file}{An object of formal class KEGGPathway}

\item{KEGG_mappings}{The data.frame object generated by the function 
expand_KEGG_mappings}
}
\value{
A dataframe object with unique entry information for all edges 
documented in the KEGG pathway. 
        Note that each row has a unique combination of values for
         (entry1, entry2, entry1symbol, entry2symbol).
}
\description{
Extract relationship information from KGML object and re-map
 based on normalized node information
}
\examples{
p53_KGML <- get_KGML("hsa04115")
p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML, FALSE)
p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/KL_compare.R
\name{KL_compare}
\alias{KL_compare}
\title{Combines all other package functions for one-step cell line comparison}
\usage{
KL_compare(pathwayid, cell_line1 = NA, cell_line2 = NA,
  refine_by_cell_line = TRUE, data_type = "100_full", pert_time = 96,
  only_mapped = TRUE, get_data = FALSE, convert_KEGG_IDs = TRUE,
  graph_title = "default", tidy_edge = TRUE, layered_nodes = FALSE)
}
\arguments{
\item{pathwayid}{A KEGG pathway ID of the form "hsa12345" 
(only human pathways currently)}

\item{cell_line1}{Choose from the set of cell lines: 
(A375,A549,ASC,HA1E,HCC515,HEK293T,HEKTE,HEPG2,HT29,MCF7,NCIH716,NPC,PC3,
SHSY5Y,SKL,SW480,VCAP)}

\item{cell_line2}{A cell line such that cell_line1 != cell_line2}

\item{refine_by_cell_line}{A logical indicator}

\item{data_type}{Choose from data types: (100_full, 100_bing, 50_lm)}

\item{pert_time}{Choose from (6,24,48,96,120,144,168)}

\item{only_mapped}{A logical indicator; if set to FALSE will return 'de-novo'
edges that 'exist' in data but are not documented in KEGG}

\item{get_data}{A logical indicator; if set to true, will return the 
'expanded' edge information for the specified pathway}

\item{convert_KEGG_IDs}{A logical indicator; if set to TRUE KEGG 
compounds will remain labeled via KEGG codes (do not need KEGGREST)}

\item{graph_title}{An optional user-specified graph title}

\item{tidy_edge}{A logical indicator; must be set to FALSE for expanded edges}

\item{layered_nodes}{A logical indicator; if set to TRUE will create a graph 
with 'stacked' nodes that the user can manipulate when multiple nodes are 
mapped to one location}
}
\value{
A dynamic map in Cytoscape automatically formatted for convenient 
viewing and, if idicated by user, a data.frame object with detailed 
information for 'expanded' KEGG edges
}
\description{
Combines all other package functions for one-step cell line comparison
}
\examples{
\dontrun{ 

# Compare p53 pathway between cell lines A375 and A549:
KL_compare("hsa04115", "A375", "A549")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/add_edge_data.R
\name{add_edge_data}
\alias{add_edge_data}
\title{Annotate KEGG edge mappings with user data}
\usage{
add_edge_data(expanded_edges, KEGG_mappings, user_data,
  data_column_no = 3, map_type = "SYMBOL", only_mapped = TRUE)
}
\arguments{
\item{expanded_edges}{The data frame object generated via the function 
expand_KEGG_edges}

\item{KEGG_mappings}{KEGG_mappings The data.frame object generated by the 
function expand_KEGG_mappings}

\item{user_data}{A data frame where in which the first two columns contain 
gene symbols representing an edge and any/all other column[s] contain 
corresponding edge data.}

\item{data_column_no}{The column index for desired user data to be added}

\item{map_type}{If the genes in your data set are left untranslated 
set to "NUMBER" (assuming numbers are gene accession numbers)}

\item{only_mapped}{A logical indicator; if set to FALSE will return 'de-novo'
edges that 'exist' in data but are not documented in KEGG}
}
\value{
A data frame object with detailed KEGG edge mappings annotated with 
user data
}
\description{
Add data column[s] to object created from function 
expand_KEGG_edges
}
\examples{
p53_KGML <- get_KGML('hsa04115')
p53_KEGG_mappings <- expand_KEGG_mappings(p53_KGML)
p53_edges <- expand_KEGG_edges(p53_KGML, p53_KEGG_mappings)
p53_HA1E_data <- overlap_info(p53_KGML, p53_KEGG_mappings, 'HA1E', 
                               data_type = '100_bing', only_mapped = FALSE)
                               
p53_edges_HA1E <- add_edge_data(p53_edges, p53_KEGG_mappings, 
                                        p53_HA1E_data, c(3, 10,12))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_KGML.R
\name{get_KGML}
\alias{get_KGML}
\title{Download and parse KGML file}
\usage{
get_KGML(pathwayid, get_if_no_edges = FALSE)
}
\arguments{
\item{pathwayid}{A KEGG pathway ID of the form "hsa12345" 
(only human pathways currently)}

\item{get_if_no_edges}{A logical indicator; if pathway has no edges 
returns null value if set to TRUE}
}
\value{
an object of Formal class KEGGPathway
}
\description{
Download and parse KGML file
}
\examples{
mtor_KGML <- get_KGML("hsa04150")

# Some pathways contain only node information; since the purpose of this
# package is to explore pathways in an edge-focused manner, the default
# options return a warning message instead of a parsed KGML file if the 
# input pathway has no edges.
ribosome_KGML <- get_KGML("hsa03020") 
ribosome_KGML <- get_KGML("hsa03020", get_if_no_edges = TRUE) 

}
